;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;global sub
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;.................................
	;copy host-table to shadow sram
	;used for dynamic mode (fast !)
	;.................................
HOTBL_copy:
	ldi	zl,low(host_table)
	ldi	zh,high(host_table)
	ldi	yl,low(host_tableSHAD)
	ldi	yh,high(host_tableSHAD)
HOTBL_copyLOOP:
	rcall	_RDe2big
	st	y+,r22
	cpi	zl,low(host_table_range)
	ldi	r16,high(host_table_range)
	cpc	zh,r16
	breq	HOTBL_copyEX
	adiw	zh:zl,1
	rjmp	HOTBL_copyLOOP
HOTBL_copyEX:
	ret




;-------------------------------------------------------
;- read eeprom
;- adress zh/zl
;- read data r22
;-------------------------------------------------------
_RDe2big:
    cli
_RDe2bigB:
	sbic	eecr,eepe		; EEPE nicht gelscht ?
	rjmp	_RDe2bigB			; warte...
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	sbi	eecr,eere		; bereite bertragung aus e2prom vor 
	in	r22,eedr		; kopiere daten aus e2prom nach r22
    sei
	ret	


;-------------------------------------------------------
;- write eeprom
;- adress zh/zl
;- read data r22
;-------------------------------------------------------
_WRe2big:
    cli
_WRe2bigB:
	sbic	eecr,eepe		; EEPE nicht gelscht ?
	rjmp	_WRe2bigB			; warte...
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	out	eedr,r22          ; kopiere ins'e2prom-datenregister
	sbi	eecr,eempe	
	sbi	eecr,eepe		;set EEPROM Write strobe
					; nach 4 maschinenzyklen ist der schreibprozess abgeschlossen 			
    sei
	ret


;-------------------------------------------------------
;- write eeprom
;- adress zh/zl
;- read data r22
;-------------------------------------------------------
_WRe2:
	sbic	eecr,eepe		; EEPE nicht gelscht ?
	rjmp	_WRe2			; warte...
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	out	eedr,r22          ; kopiere ins'e2prom-datenregister
	sbi	eecr,eempe	
	sbi	eecr,eepe		;set EEPROM Write strobe
					; nach 4 maschinenzyklen ist der schreibprozess abgeschlossen 			
	ret




;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;wait for buffer free sub
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
rfm12_WT:
	lds	r16,TRANS_state
 	sbrs	r16,nRFirqEV		;nIRQ Event
  	rjmp	rfm12_WT
	cbr	r16,1<<nRFirqEV
	sts	TRANS_state,r16
	ret






	


