;***************************************
;spi-init sub
;***************************************
;A) SPI-master: 
;* polled tx
;* clocked Fclk/16 
;* for system/if communication
;* global interrupts during init disabled
;***************************************
_SPImasterINIT:
    cli
    ;set _ifSEL low from pullup
    cbi ddrb,_ifSEL
    cbi portb,_ifSEL
    nop
    sbi ddrb,_ifSEL
    cbi portb,_ifSEL   
	;output-pins
	in	r16,ddrb
	sbr	r16,1<<_SS
	sbr	r16,1<<MOSI
	sbr	r16,1<<SCK ;
	out	ddrb,r16
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<MSTR
	sbr	r16,1<<SPR0    
	out	spcr,r16
	;read spsr	(clear spif bit)
	in	r16,spsr
 	;danach spdr lesen
	in	r16,spdr
    sei
	;
	ret


;***************************************
;B) SPI-master: 
;* polled tx
;* clocked Fclk/16 
;* for if/rfm communication
;* global interrupts during init disabled
;***************************************
_SPImasterRFMINIT:
    cli
    ;set _ifSEL low from pullup
    cbi ddrb,_ifSEL
    cbi portb,_ifSEL
    nop
    sbi ddrb,_ifSEL
    cbi portb,_ifSEL
    ;set _SS input
    sbi	portb,_SS
	;output-pins
	in	r16,ddrb
    sbr r16,1<<_SS
	sbr	r16,1<<MOSI
	sbr	r16,1<<SCK ;
	out	ddrb,r16
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<MSTR
	sbr	r16,1<<SPR0
	out	spcr,r16
	;read spsr	(clears spif bit)
	in	r16,spsr
 	;danach spdr lesen
	in	r16,spdr
    ;clear MANstate
	clr		r16
	sts		MANstate,r16	
    sei
	ret


;***************************************
;C) SPI-master: 
;* polled tx
;* clocked Fclk/16 
;* for if/rfm communication
;***************************************
_SPImasterRFMINITb:
   ;set _ifSEL low from pullup
    cbi ddrb,_ifSEL
    cbi portb,_ifSEL
    nop
    sbi ddrb,_ifSEL
    cbi portb,_ifSEL
    ;set _SS input
    sbi	portb,_SS
	;output-pins
	in	r16,ddrb
    sbr r16,1<<_SS
	sbr	r16,1<<MOSI
	sbr	r16,1<<SCK 
	out	ddrb,r16
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<MSTR
	sbr	r16,1<<SPR0
	out	spcr,r16
	;read spsr	(clears spif bit)
	in	r16,spsr
 	;danach spdr lesen
	in	r16,spdr
    ;clear MANstate
	clr		r16
	sts		MANstate,r16

 	ret








;***************************************
;D) SPI-slave: 
;* enables interrupt receiving
;* for system/if communication
;* global interrupts during init disabled
;***************************************
_SPIslaveINIT:
    cli
	lds	r16,comFLAG
	cbr	r16,1<<spiBUSYhif
	cbr	r16,1<<spiBUSYnet
    cbr r16,1<<RFMbusy	
  	sts	comFLAG,r16
    ;set high
    sbi	portb,_SS
	;output-pins
	in	r16,ddrb
	sbr	r16,1<<MISO 		
    cbr r16,1<<_SS
    cbr r16,1<<_ifSEL
	out	ddrb,r16			
	;set _ifSEL high
	sbi	portb,_ifSEL
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<SPIE 	
	out	spcr,r16
	;read spsr	(clears spif bit)
	in	r16,spsr
	;danach spdr lesen
	in	r16,spdr
    sei
	ret




;***************************************
;E) SPI-slave: 
;* enables interrupt receiving
;* for system/if communication
;***************************************
_SPIslaveINITb:
   	lds	r16,comFLAG
	cbr	r16,1<<spiBUSYhif
	cbr	r16,1<<spiBUSYnet
    cbr r16,1<<RFMbusy	
  	sts	comFLAG,r16
    ;set high
    sbi	portb,_SS
	;output-pins
	in	r16,ddrb
	sbr	r16,1<<MISO 	
    cbr r16,1<<_SS
    cbr r16,1<<_ifSEL
	out	ddrb,r16	
	;set _ifSEL high
	sbi	portb,_ifSEL
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<SPIE 	
	out	spcr,r16
	;read spsr	(clears spif bit)
	in	r16,spsr
	;danach spdr lesen
	in	r16,spdr
	ret
