;-------------------------------------------------------------
;uart receive fifo svr // 112500 bps
;-------------------------------------------------------------
Suart_SVR:
    push    r5
    push    r16
    push    zl
    push    zh
    in      r5,sreg
    ;---------------------------------
    ;load data from uart
    lds     r16,udr0
    ;---------------------------------
    ;check state
    lds     zl,RS485state
    sbrs    zl,RS485from
    rjmp    Suart_SVRgo
    ;new data received, but old data 
    ;still in buffer...
    sbr     zl,1<<RS485wait
    sts     RS485state,zl
    ;clear pointer
    clr     r16
    sts     rs485FIFOpoint,r16
    rjmp    Suart_SVRreti
    ;---------------------------------
    ;adress buffer
Suart_SVRgo:
    lds     zl,rs485FIFOpoint
    clr     zh
    subi    zl,low(-rs485NETbuffer)
    sbci    zh,high(-rs485NETbuffer)
    ;---------------------------------
    ;store data to buffer
    st      z,r16
    ;---------------------------------
    ;check...
    ;pointer =0 first byte
    lds     zl,rs485FIFOpoint
    lds     zh,rs485RECsize
    tst     zl
    brne    Suart_SVRsiz            ;pointer >0
    ;=0
    ldi     zh,0xff
    sts     rs485RECsize,zh
    ;start calculating ck-sum
    ldi     zh,0xaa
	eor	    zh,r16
    sts     rs485ckSUM,zh
    ;busy
    lds     r16,RS485state
    sbr     r16,1<<RS485busy
    sts     RS485state,r16
    ;pointer +1 
    inc     zl
    sts     rs485FIFOpoint,zl
    rjmp    Suart_SVRreti           ;back for next byte...
    ;----------------------------------
    ;check...
    ;5? points to framesize
Suart_SVRsiz:
    cpi     zl,5
    brne    Suart_SVRpoint
    sts     rs485RECsize,r16    ;store framesize    
    mov     zh,r16
    ;-----------------------------------
    ;pointer +1
Suart_SVRpoint:
    inc     zl
    sts     rs485FIFOpoint,zl
    ;------------------------------------
    ;check size ?
    cp      zl,zh
    brsh    Suart_SVRready
    ;------------------------------------
    ;<size .. update checksum
    lds     zh,rs485ckSUM
    eor     zh,r16
    sts     rs485ckSUM,zh
    ;-------------------------------------
    ;reti in loop
    rjmp    Suart_SVRreti
    ;-------------------------------------
    ;ready loaded = check sum ok ?
Suart_SVRready:
	lds	zl,rs485ckSUM
    cp  zl,r16          ;compare actual data (ck-sum) with calculated
    brne  Suart_SVRfail ;not ok!
    ;ok!
    subi    zh,1        ;frame-size -1 
    mov     r16,zh
    ldi     zl,5     
    clr     zh
    subi    zl,low(-rs485NETbuffer)
    sbci    zh,high(-rs485NETbuffer)
    st      z,r16       ;store new frame-size
    ;--------------------------------------
    ;data ok !
    ;check if broadcast...
    ldi    zl,low(rs485NETbuffer)
    ldi    zh,high(rs485NETbuffer)
    ld     r16,z+
    sbrs   r16,b_cast       
    rjmp   Suart_SVRreadyGO         ;broadcast - ok !
    ;no broadcast - check adress
    ld     r16,z                    ;load lab target adress
    lds     zl,Shost_adr            ;compare...
    cp      r16,zl
    brne    Suart_SVRfail
    ;equal = ok!
Suart_SVRreadyGO:
    ;set flags
    lds     r16,RS485state
    sbr     r16,1<<RS485from
    sts     RS485state,r16
    ;---------------------------------------
    ;pointer reset
Suart_SVRfail:
    lds     r16,RS485state
    cbr     r16,1<<RS485busy
    sts     RS485state,r16
    ;
    clr     r16
    sts     rs485FIFOpoint,r16
    ;---------------------------------------
    ;reti from svr
Suart_SVRreti:
    out     sreg,r5
    pop     zh
    pop     zl
    pop     r16
    pop     r5
	reti
