;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;scan_000HOtable
;* needed for network scan function
;* build & update scan host-table in shadow ram
;* including garbage collector
;=>table-structure: <dyn.segment-size><direct-host><direct-host-qual><mesh-host><mesh-host-quality>.....
;--------------------------------------------------------------------------------------------------------------------------------
;the received scan-frame-structure:
;<mode-instr.>|<#meshed hosts>|<host-adress>|<scan-adress>|<host-quality>|<n*mesh-host>|<n*mesh-host quality>|<checksum 8bit>
;
;explaining in shortform:
;#meshed hosts			<=>	count of meshed host stored by the scanned host
;scanned-adress		    <=>	adress of the scanned host
;host-quality			<=>	received data quality by this scan
;n*mesh-host			<=> adress of a meshed host stored by the scanned host
;n*mesh-host quality	<=>	meshed host data quality, stored by the scanned host
;host-adress			<=>	this devices adress
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
scan_000HOtable:
	;*********************************
	;A)calculate <dyn.segment-size>
	;= FRAME_siz - 3
	;*********************************
	lds	r16,FRAME_siz
	subi	r16,3
	sts	tSEG_siz,r16
	ldi	r16,1
	sts	CNTa,r16		;help counter
	;*********************************
	;D) check size & write size to e2p
	;*********************************
	lds	zl,HtablePOSl
	lds	zh,HtablePOSh
	lds	r22,tSEG_siz
	inc	r22
	clr	xh
	add	zl,r22
	adc	zh,xh
	;range ?
	cpi	zl,low(host_tableSHADrange)
	ldi	xh,high(host_tableSHADrange)
	cpc	zh,xh
	brlo	scan_000HOtableX
	;out of range /do not store
	jmp	scan_001HOtableSTOREex

scan_000HOtableX:
	lds	r22,tSEG_siz
	lds	zl,HtablePOSl
	lds	zh,HtablePOSh
	st	z+,r22	;pointer+1
	;*********************************
	;B) set startadress rfm_buffer
	;*********************************
	ldi	yl,3
	clr	yh
	subi	yl,low(-rfm_buffer)
	sbci	yh,high(-rfm_buffer)
	;..................................
	ldi	r16,1
	sts	CNTa,r16		;help counter A
	clr	r16
	sts	CNTb,r16		;help counter B





	;*********************************
	;E) write loop
	;*********************************
scan_000HOtableLOOP:
	lds	r22,CNTa
	lds	r23,tSEG_siz
	cp	r22,r23
	breq	scan_001HOtable	;ready stored
	;......................
	;don't store the own
	;host adress as a mesh!
	;......................
	cpi	r22,3
	breq	scan_001HOtableMESH	;from the 4th byte meshes hosts
scan_000HOtableLOOPb:
	;meshed ?
	lds	r16,CNTb
	tst	r16
	breq	scan_000HOtableLOOPstoreDIRECT
	;meshed !
	lds	r17,Shost_adr	
	ld	r22,y
	cp	r17,r22
	brne	scan_000HOtableLOOPstoreMESH

	;.................................
	;equal !
	;.................................
	clr	r22
	;pointer +1
	adiw	yh:yl,2
	;counter +2
	lds	r22,CNTa
	inc	r22
	inc	r22
	sts	CNTa,r22
	jmp	scan_000HOtableLOOP	;loop...

	scan_001HOtableMESH:
			ldi	r16,1
			sts	CNTb,r16
			jmp	scan_000HOtableLOOPb



scan_000HOtableLOOPstoreMESH:
	;load data
	ld	r22,y+
	st	z+,r22	;pointer +1
	;load data
	ld	r22,y+
	st	z+,r22	;pointer +1
	;counter +2
	lds	r22,CNTa
	inc	r22
	inc	r22
	sts	CNTa,r22
	;mesh counter+1
	lds	r22,CNTb
	inc	r22
	sts	CNTb,r22
	jmp	scan_000HOtableLOOP	;loop...


	

scan_000HOtableLOOPstoreDIRECT:
	;load data
	ld	r22,y+
	st	z+,r22	;pointer +1
	;counter +1
	lds	r22,CNTa
	inc	r22
	sts	CNTa,r22
	jmp	scan_000HOtableLOOP	;loop...



	;**********************************
	;F) store new size
	;  &store table position
	;**********************************
scan_001HOtable:
	lds	r16,CNTb
	tst	r16
	breq	scan_001HOtableNOMESH
	subi	r16,1
	ldi	r17,2
	mul	r16,r17
	ldi	r22,3
	add	r22,r0
	jmp	scan_001HOtableSTORE

scan_001HOtableNOMESH:
	ldi	r22,3
scan_001HOtableSTORE:
	push	zh
	push	zl
	lds	zl,HtablePOSl
	lds	zh,HtablePOSh
	st	z,r22
	pop	zl
	pop	zh
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh
scan_001HOtableSTOREex:
	ret














;*******************************************************************************************
;scan_100HOtable = garbage collector FIRST LEVEL
;                * check if there's a double stored direct host & clear the segment if necessary
;			     * check if any meshed host can be directly adressed
;		           TRUE:  clear the specified mesh-host in all segments
;		           FALSE: goon with next direct host until reaching the limit 
;*******************************************************************************************
scan_100HOtable:
	;startadresses
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh

  	;......................................
	;check size - valid ?
	;......................................
scan_101HOtableLOOP:
    ;.........................
    ;range?
    ;.........................
    call    hoTABLErange
    tst     xl
    breq    scan_101HOtableLOOPb
	jmp	    scan_101HOtableDscanEXIT          ;adress next host segment
         

scan_101HOtableLOOPb:
	lds	zl,HtablePOSl
	lds	zh,HtablePOSh
	ld	r22,z
	sts	tSEG_siz,r22
	;0= this & further segments free
	;255=segment is free or invalid
	cpi	r22,255
	brlo	scan_101HOtableX
	jmp	scan_101HOtableDscanCLEAR	;segment or further is free <=> exit
scan_101HOtableX:
	tst	r22
	brne	scan_101HOtableRUN	    ;data in segment
	jmp	scan_101HOtableDscanCLEAR	;segment or further free    <=> exit

 
 
 
 
 
                       ;.....................................
                       ;actual direct host adress invalid
                       ;clear the host segment !
                       ;.....................................
                scan_101HOtableCLEARSEG:
                        lds r22,tSEG_siz
                        subi    r22,1
                        clr r23
                scan_101HOtableCLEARSEGloop:
                        st  z+,r23
                        dec r22
                        breq    scan_101HOtableCLEARSEGloopEX
                        rjmp    scan_101HOtableCLEARSEGloop
                scan_101HOtableCLEARSEGloopEX:
                       	sts	HtablePOSl,zl
                	    sts	HtablePOSh,zh
                        jmp scan_101HOtableLOOP
 
 
 
    ;......................................
    ;size valid !
	;host(s) in segment - valid ?
    ;......................................
scan_101HOtableRUN:
	adiw	zh:zl,1			;pointer +1
	ld	r22,z
	sts	DIRhost,r22		;store direct accessible host	
	;direct host =0 invalid...
	tst	r22
	breq	scan_101HOtableCLEARSEG     ;segment invalid == clear it!
    cpi r22,0xff
    breq    scan_101HOtableCLEARSEG     ;segment invalid == clear it!

   

;............................................................
;size & hostadress valid !
;- actual segment size in <tSEG_siz>
;- actual direct host adress in <DIRhost>
;first check if the following segments are containing the
;actually direct host adress.
;Yes - clear the segment
;No  - goon
;............................................................

scan_101HOtableCHECKDOUBLE:
    ldi	yl,low(host_tableSHAD)
	ldi	yh,high(host_tableSHAD)
	sts	SCtablePOSl,yl
	sts	SCtablePOSh,yh
    lds r5,DIRhost                          ;actually direct host for scan
    clr r23
    sts CNTa,r23
    sts CNTb,r23


scan_101HOtableCHECKDOUBLEloop:
	lds	yl,SCtablePOSl
	lds	yh,SCtablePOSh
    ld  r22,y+  ;load segment size
    sts SCseg_siz,r22
    tst r22
    breq   scan_101HOtableNEXTSEG           ;adress next host segment
    cpi r22,0xff
    breq   scan_101HOtableNEXTSEG           ;adress next host segment
    ld  r23,y    ;load direct host adress
    cp  r5,r23
    breq   scan_101HOtableCHECKDOUBLEgo ;double?

    ;...............................
    ;check for equal meshed hosts
    ;...............................
    cpi r22,4
    brlo    scan_101HOtableCHECKDOUBLEloopADR   ;there are no meshed in segment


scan_101HOtableCHECKMESHloop:
    ;yes meshed in table !
    adiw    yh:yl,2     ;points to the meshed adress
    subi    r22,2       
    ld  r23,y
    cp  r5,r23
    breq  scan_101HOtableCLEARMESH
    cpi r22,4
    brlo    scan_101HOtableCHECKDOUBLEloopADR   
    jmp scan_101HOtableCHECKMESHloop
   
   ;....................................
   ;clear meshed adress &quality factor
   ;....................................
scan_101HOtableCLEARMESH:
    clr r23
    st  y+,r23
    st  y,r23
    sbiw    yh:yl,1
    jmp scan_101HOtableCHECKMESHloop


    
    ;.........................
    ;adressing next scan segment 
    ;.........................
scan_101HOtableCHECKDOUBLEloopADR:
    clr r23
    subi    r22,1
    add yl,r22
    adc yh,r23
	sts	SCtablePOSl,yl
	sts	SCtablePOSh,yh
    
    ;.........................
    ;range?
    ;.........................
    call    scTABLErange
    tst     xl
    breq    scan_101HOtableCHECKDOUBLEloop
	jmp	    scan_101HOtableNEXTSEG          ;adress next host segment
         



;.............................................
;check for double direct host adress
;.............................................
scan_101HOtableCHECKDOUBLEgo:
    lds r23,CNTa
    tst r23
    breq  scan_101HOtableCHECKDOUBLEgoNXT   ;no double  
    ;double !
    ;clear the scanned segment
    lds r22,SCseg_siz
    subi    r22,1
    clr r23
scan_101HOtableCHECKDOUBLEgoloop:
    st  y+,r23
    dec r22
    breq    scan_101HOtableCHECKDOUBLEgoloopEX
    rjmp    scan_101HOtableCHECKDOUBLEgoloop
scan_101HOtableCHECKDOUBLEgoloopEX:
   	sts	SCtablePOSl,yl
	sts	SCtablePOSh,yh
    jmp scan_101HOtableCHECKDOUBLEloop

scan_101HOtableCHECKDOUBLEgoNXT:
    inc r23
    sts CNTa,r23
    jmp scan_101HOtableCHECKDOUBLEloopADR



        ;...............................................
        ;invalid scan data - adress next host segment
        ;...............................................
        scan_101HOtableNEXTSEG:
        	lds	zl,HtablePOSl
        	lds	zh,HtablePOSh
            lds xl,tSEG_siz
            clr xh
            add zl,xl
            adc zh,xh
        	sts	HtablePOSl,zl
            sts	HtablePOSh,zh
            jmp scan_101HOtableLOOP




;....................................
;check scan table size
;result in xl
;....................................
scTABLErange:
	lds	yl,SCtablePOSl
	lds	yh,SCtablePOSh
	;range scan?
	cpi	yl,low(host_tableSHADrange)
	ldi	xh,high(host_tableSHADrange)
	cpc	yh,xh
    brsh    scTABLErangeOV
    clr xl
    ret
scTABLErangeOV:
    ldi xl,1
    ret





;.....................................
;check host table size
;z-regs
;.....................................
hoTABLErange:
	lds	yl,HtablePOSl
	lds	yh,HtablePOSh
	;range scan?
	cpi	yl,low(host_tableSHADrange)
	ldi	xh,high(host_tableSHADrange)
	cpc	yh,xh
    brsh    hoTABLErangeOV
    clr xl
    ret
hoTABLErangeOV:
    ldi xl,1
    ret






	;...........................
    ;EXIT
	;further segments containing 
	;invalid data == delete
	;...........................
scan_101HOtableDscanCLEAR:
	clr	r22
	st	z,r22	;clear data
	;range scan?
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brsh	scan_101HOtableDscanEXIT	;in range
	adiw	zh:zl,1
	jmp	scan_101HOtableDscanCLEAR
	;............................
	;direct host scan ready
	;............................
scan_101HOtableDscanEXIT:
	;startadresses
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh
	ldi	yl,low(host_tableSHAD)
	ldi	yh,high(host_tableSHAD)
	sts	SCtablePOSl,yl
	sts	SCtablePOSh,yh

;including level II
jmp scan_110HOtable






;TEST IT
	;**********************************
	;C) ready / out of range
	;-> restore to e2p
	;**********************************
scan_107HOtable:
	;startadresses e2p host table
	ldi	zl,low(host_table)
	ldi	zh,high(host_table)
	;startadresse shadow host table
	ldi	yl,low(host_tableSHAD)
	ldi	yh,high(host_tableSHAD)
	;startadress temp. sram mirror
;	ldi	yl,low(TE_garbage_seg)
;	ldi	yh,high(TE_garbage_seg)
scan_108HOtable:
	;store to e2p table
	ld	r22,y+
	call	_WRe2big	
	;store to shadow table
;	st	x,r22
	;range
	cpi	zl,low(host_table_range)
	ldi	r23,high(host_table_range)
	cpc	zh,r23
	brsh	scan_109HOtable
	adiw	zh:zl,1
	adiw	xh:xl,1
	jmp	scan_108HOtable		;write loop...
scan_109HOtable:
	ret





















;*******************************************************************************************
;scan_110HOtable = garbage collector SECOND LEVEL
;                * copy the host-segments with the corrected size to the mirror storage (sram)
;			       NOTE: segments with invalid direct hosts (=0) will be deleted
;			     * restore to the e2p-host table
;*******************************************************************************************	
scan_110HOtable:
	;startadress temp. sram mirror
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
	clr	r5
	;clear tbl_buffer
scan_110HOtableCLR:
	st	y,r5
	cpi	yl,low(TE_garbage_segRANGE)
	ldi	r23,high(TE_garbage_segRANGE)
	cpc	yh,r23
	brsh	scan_110HOtableGO
	adiw	yh:yl,1
	jmp	scan_110HOtableCLR
scan_110HOtableGO:
	;startadresses host table
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	;startadress temp. sram mirror
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
	jmp	scan_111HOtable
	;
	;************************************
	;A) check segment if there're
	;invalid mesh hosts
	;YES: correct the <dyn.segment size>
	;     n' copy to the mirror without
	;     the invalid mesh-host&quality 
	;	 factor
	;NO:  copy the complete segment to
	;     the mirror
	;************************************
scan_120HOtableX:
	jmp	scan_120HOtable
scan_111HOtable:
	;base size
	ldi	r22,3
	sts	tSEG_siz,r22		;store to temp size
	;store <dyn.segment size>-position
	sts	HtablePOSl,yl
	sts	HtablePOSh,yh
	ld	r22,z	 
	sts	SCseg_siz,r22		;store old size to mirror !
	tst	r22
	breq	scan_120HOtableX	;no data in this or further segments
	cpi	r22,255
	breq	scan_120HOtableX	;no data in this or further segments
	mov	r4,r22			;backup r22
	adiw	zh:zl,1
	ld	r22,z		;store direct host adress to mirror
	;direct host =0
	;then delete complete
	;segment !
	tst	r22
	brne	scan_111HOtableGOx
	jmp	scan_111HOtableCLR
scan_111HOtableGOx:
	cpi	r22,0xff
	brne	scan_111HOtableGO






	;.....................................
	;don't store to buffer
	;.....................................
scan_111HOtableCLR:
	;=0/255
	;set table_adress to next segment !
	clr	r23
	lds	r22,SCseg_siz
	subi	r22,1			;because z-pointer was already added by +1
	add	zl,r22
	adc	zh,r23
	;check range
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brlo	scan_111HOtable
	jmp	scan_120HOtable		;out of range



	;............................
	;store ro buffer
	;............................
scan_111HOtableGO:
	st	y+,r4
	st	y+,r22
	adiw	zh:zl,1
	ld	r22,z			;store direct host quality to mirror
	st	y+,r22
	;**********************
	;check if ther's any
	;mesh-host in segment?
	;**********************
	adiw	zh:zl,1			;points to th enext segment OR first meshed host
	lds	r22,SCseg_siz
	cpi	r22,4
	brsh	scan_112HOtable	;there' a mesh-hosts in table
	;**********************
	;no mesh-hosts
	;=> goto next segment
	;startadress
	;**********************
	;range
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brlo	scan_111HOtable
	jmp	scan_120HOtable		;out of range
	;*******************************
	;check valid/invalid mesh-hosts
	;*******************************
scan_112HOtable:
	ld	r22,z	 
	tst	r22					;0= invalid !
	breq	scan_114HOtable		;invalid
	;valid! store adress
	st	y+,r22
	adiw	zh:zl,1
	ld	r22,z	 
	;store quality
	st	y+,r22
	adiw	zh:zl,1
scan_113HOtable:
	;now check segment size
	lds	r22,tSEG_siz
	ldi	r23,2
	add	r22,r23
	sts	tSEG_siz,r22			;temp. size +2
	lds	r23,SCseg_siz
	cp	r22,r23
	brne	scan_112HOtable		;segment ready - next segment
	jmp	scan_111HOtable		;next mesh-host 

	;******************************
	;B) invalid mesh
	;******************************
scan_114HOtable:
	push	yl
	push	yh
	lds	yl,HtablePOSl
	lds  yh,HtablePOSh
	lds	r22,SCseg_siz
	subi	r22,2
	sts	SCseg_siz,r22
	st	y,r22	 		;store new size (-2)
	pop	yh
	pop	yl
	adiw	zh:zl,2
	lds	r23,tSEG_siz
	cp	r22,r23
	brne	scan_112HOtable		;segment ready - next segment
	jmp	scan_111HOtable		;next mesh-host 






















	;**********************************
	;C) ready / out of range
	;-> restore to e2p
	;**********************************
scan_120HOtable:
	;startadresses e2p host table
	ldi	zl,low(host_table)
	ldi	zh,high(host_table)
	;startadresse shadow host table
	ldi	xl,low(host_tableSHAD)
	ldi	xh,high(host_tableSHAD)
	;startadress temp. sram mirror
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
scan_121HOtable:
	;store to e2p table
	ld	r22,y+
	call	_WRe2big	
	;store to shadow table
	st	x,r22
	;range
	cpi	zl,low(host_table_range)
	ldi	r23,high(host_table_range)
	cpc	zh,r23
	brsh	scan_122HOtable
	adiw	zh:zl,1
	adiw	xh:xl,1
	jmp	scan_121HOtable		;write loop...
scan_122HOtable:
	ret












;*******************************************************************************************
;scan_130HOtable = Dynamic table-scanner in shadow ram
;                * check if there's an equal direct host exists in a segment 
;		           TRUE:  set all adresses in segment =0 and copy the new frame to a free segment
;		           FALSE: copy the new frame to a free segment (scan_000HOtable)
;
;=> STATErecTE (7/8) necessary
;=> DIRhostREC (recorded alive/kill direct host adress) necessary
;*******************************************************************************************
scan_130HOtable:
	;startadresses
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh
	sts	SCtablePOSl,zl
	sts	SCtablePOSh,zh
    ;
	lds	r16,STATErecTE				;stored in receive mode=9 (change LHA)
	cpi	r16,9
    brne   scan_131HOtable
    jmp  scan_150HOtable
    ;

	;************************************
	;A) read direct host from shodow ram
	;************************************
scan_131HOtable:
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	ld	r22,z
	sts	SCseg_siz,r22
	;0= this & further segments free
	tst	r22
	breq	scan_140HOtable	;segment free for storing new frame 
	cpi	r22,0xff
	breq	scan_140HOtable	;segment free for storing new frame 
scan_131HOtableRUN:
	adiw	zh:zl,1			;pointer +1
	ld	r22,z
	sts	DIRhost,r22		;store direct accessible host 
	lds	r23,DIRhostREC		;NOTE: find also segments with an equal direct hot adress !!!!
	cp	r22,r23
	brne	scan_131HOtableNEQU	;adress ok
	jmp	scan_132HOtable	;equal adress found == clear!
	;........................
	;stored direct adress
	;is not equal to the received
	;direct adress !
	;........................
scan_131HOtableNEQU:
	;CALCULATE NEXT
	;SEGMENT STARTADRESS
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	lds	r22,SCseg_siz
	clr	r23
	add	zl,r22
	adc	zh,r23
	;range ?
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brlo	scan_131HOtableGO
	jmp	scan_141HOtable		;out of range == table full
scan_131HOtableGO:	
	sts	SCtablePOSl,zl
	sts	SCtablePOSh,zh
	jmp	scan_131HOtable		;loop
	;............................
	;equal direct adress is found
	;in this segment !
	;clear adresses NOT the size
	;NOTE: size is needed by the
	;garbage collector
	;............................ 
scan_132HOtable:
	lds	r17,SCseg_siz
	ldi	r16,1
	sts	CNTa,r16
	clr	r22					;adress & quality =0
scan_132HOtableLOOP:					
	cp	r16,r17
	brsh	scan_132HOtableREADY	;all adresses in segment are cleared
	st	z+,r22			;write adress=0 &pointer +1
	inc	r16
	jmp	scan_132HOtableLOOP		;in loop 
scan_132HOtableREADY:
	jmp	scan_131HOtableNEQU		;now search again (an equal host OR a free segment)

	;...............................................................................................................................................................
	;store new frame in segment
	;...............................................................................................................................................................
scan_140HOtable:
	;startadress of the free segment
	;NOTE: observe the max. range !
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh
	;restore framesize
	lds	r16,tSEG_siz			;stored (rx-mode 7)	
	sts	FRAME_siz,r16
	;............................
	;pay attention that only alive
	;meassges will be stored zo
	;the host table.
	;kill messages are clearing
	;the segment without further
	;storing...
	;............................
	lds	r16,STATErecTE				;stored in receive mode=7/8
	cpi	r16,7
	breq	scan_140HO7table			;mode 7 == alive (storing to table)
	cpi	r16,8
	breq	scan_140HO8table			;mode 8 == kill (storing to table)
	jmp	scan_141HOtable			;invalid (not 7 or 8)
scan_140HO7table:
	call 	scan_000HOtable		;store to free segment & ret
scan_140HO8table:
	call	scan_100HOtable
	;............................
	;return with(out)storing data
	;...........................
scan_141HOtable:
	ret




;**********************************************************************************************************
;search for OLDShost_adr in table & exchange with the new one !
;**********************************************************************************************************
scan_150HOtable:
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	ld	r16,z
	sts	SCseg_siz,r16
	;0= this & further segments free
	tst	r16
	breq	scan_151HOtable	;no data in segment...
	cpi	r16,0xff
	breq	scan_151HOtable	;no data in segment...
    ;data in segment...
scan_150HOtableRUN:
	adiw	zh:zl,1			;pointer +1
	ld	r22,z               ;load host adress, perhaps the old adress of the calling LHA-change host ?
	lds	r23,OLDShost_adr		
	cp	r22,r23
	brne	scan_150HOtableNEQU	;adress not equal
    ;yes - old adress found!
    lds r22,Thost_adr
    st  z+,r22
    ;points to the next storage adress
    sts SCtablePOSh,zh
    sts SCtablePOSl,zl
    ;size - 2
    subi    r16,2
    ;size =1 ready for next segment
    cpi r16,1
    breq    scan_150HOtable
    rjmp    scan_150HOtableRUN

    ;not equal
scan_150HOtableNEQU:
	adiw	zh:zl,1			;pointer +1
   ;points to the next storage adress
    sts SCtablePOSh,zh
    sts SCtablePOSl,zl
    ;size - 2
    subi    r16,2
    ;size =1 ready for next segment
    cpi r16,1
    breq    scan_150HOtable
    rjmp    scan_150HOtableRUN

    ;store shadow to e2p host table
scan_151HOtable:
    call	scan_120HOtable
    ;....................................
    ;transfer host table to concept...
    ;- 10bytes payload
    ;- mi (mi3/mi6=1)
    ;- framesize=17
    ;- type=8
    ;....................................
    call    _SPImasterINIT
    call    scan_190HOtable
    call    _SPImasterRFMINIT
    ret







;*****************************************************************************************************************
;scan_160HOtable =  scanning the host-table for available host adresses !
;                *  Dynamic host-finder / input: <Thost_adr>
;                *  check if there's an equal direct host or meshed host exists in a segment 
;		         => A DIRECT FOUND: set <DIRhost> == searched <Thost_adr>/<T2host_adr>==0 (no mesh must be used)
;		         => A MESHED FOUND: set <DIRhost> == segment direct host/<T2host_adr>== searched target adress
;******************************************************************************************************************

scan_160HOtable:
	;defaults
	clr	zl
	sts	DIRhost,zl
	sts	T2host_adr,zl
	;startadresses
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	sts	SCtablePOSl,zl
	sts	SCtablePOSh,zh

	;************************************
	;A) read direct host from shadow
	;************************************
scan_161HOtable:
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	ld	r22,z
	sts	SCseg_siz,r22
	;0= this & further segments free
	tst	r22
	brne	scan_161HOtableA	;data in segment ?
    jmp	scan_165HOtable	        ;=0 this n' further segments free - exit!    
scan_161HOtableA:
	cpi	r22,0xff
	brne	scan_161HOtableRUN	;data in segment
	jmp	scan_165HOtable	        ;=0xFF this n' further segments free - exit!

	;compare direct host in segment
scan_161HOtableRUN:
	adiw	zh:zl,1			;pointer +1
	ld	r22,z
	;compare with searched adress
	sts	DIRhost,r22		;maybe the direct host
	lds	r23,Thost_adr
	cp	r22,r23
	breq	scan_165HOtable	;as a direct found
	;search for meshed hosts
	;if ther are any !
	lds	r16,SCseg_siz
	cpi	r16,4
	brsh	scan_161HOtableRUNmesh

scan_161HOtableRUNnomesh:
	;no meshed hosts
	;-> next segment
	lds	r16,SCseg_siz
	clr	r17
	lds	zh,SCtablePOSh
	lds	zl,SCtablePOSl
	add	zl,r16
	adc	zh,r17
	sts	SCtablePOSl,zl
	sts	SCtablePOSh,zh
	;clear direct host
	sts	DIRhost,r17
	sts	T2host_adr,r17
	;check limit
	;range ?
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brlo	scan_161HOtable
	jmp	scan_165HOtable		;out of range


scan_161HOtableRUNmesh:
	subi	r16,3			;three bytes are readen
	sts	CNTd,r16			;temporary size
scan_161HOtableRUNmeshLOOP:
	adiw	zh:zl,2			;points to the first meshed
	ld	r22,z
	;compare with searched adress
	sts	T2host_adr,r22		;maybe the direct host
	lds	r23,Thost_adr
	cp	r22,r23
	breq	scan_165HOtable	;as a meshed found
	lds	r16,CNTd			;counter
	subi	r16,2	
	tst	r16
	breq	scan_161HOtableRUNnomesh				;new segment check
	sts	CNTd,r16
	jmp	scan_161HOtableRUNmeshLOOP

scan_165HOtable:
	ret






;*******************************************************************************************
;scan_170HOtable = Direct host table-scanner (used for: alive send)
;                * returns with a complete tx-frame
;*******************************************************************************************
scan_170HOtable:
	;adresspointer rfm-buffer // point == first host adress
	lds	yl,TXbufPOINTl
	lds	yh,TXbufPOINTh
	;table startadress
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	;clear mesh counter
	clr	r22
	sts	CNTd,r22
	;
scan_170HOtableA:
	ld	r22,z
	sts	SCseg_siz,r22
	;*************************
	;check size
	;*************************
	tst	r22
	breq	scan_170HOtableREADY	;invalid	
	cpi	r22,255
	breq	scan_170HOtableREADY	;invalid
	;*************************
	;load checksum
	;*************************
	lds	r17,txCKsum
	;to checksum
	adiw	zh:zl,1
	ld	r22,z
			;.........................
			;adr=0 ?
			tst	r22
			breq	scan_170HOtableAINV
			;adr=255
			cpi	r22,0xff
			breq	scan_170HOtableAINV
			;.........................

	st	y+,r22				;direct host adress
	eor	r17,r22
	;
	adiw	zh:zl,1
	ld	r22,z
	st	y+,r22				;direct host quality
	eor	r17,r22
	;************************
	;store checksum
	;************************
	sts	txCKsum,r17
	;************************
	;direct count +1
	;************************
	lds	r22,CNTd
	inc	r22
	sts	CNTd,r22
	;************************
	;next segment
	;************************
scan_170HOtableAnxtSEG:
	lds	r22,SCseg_siz
	subi	r22,2
	clr	r23
	add	zl,r22
	adc	zh,r23
	;************************
	;check range
	;************************
	;check limit
	;range ?
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brsh	scan_170HOtableREADY
	jmp	scan_170HOtableA

scan_170HOtableAINV:
	adiw	zh:zl,1
	jmp	scan_170HOtableAnxtSEG

	;*************************
	;return with completed 
	;tx_frame
	;including: frame_siz
	;		  checksum
	;*************************
scan_170HOtableREADY:
	ldi	zh,high(rfm_buffer)
	ldi	zl,low(rfm_buffer)
	adiw	zh:zl,1
	lds	r22,CNTd				;store direct count
	st	z,r22
	;to checksum
	lds	r17,txCKsum
	eor	r17,r22
	;& store
	st	y,r17
	;calculate framesize
	ldi	r17,6				;basic size
	lds	r22,CNTd				;count of direct (&qual)*2
	ldi	r23,2
	mul	r22,r23
	add	r17,r0
	sts	FRAME_siz,r17
	ret



;*******************************************************************************************
;scan_180HOtable = Direct host table-scanner (used for: broadcast)
;                * stores the available direct hosts to the temporary buffer <TE_garbage_seg>
;		         * stores th count of direct-hosts to the var <HOcnt>
;*******************************************************************************************
scan_180HOtable:
	;table startadress
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	;startadress temp. sram mirror
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
	;clear host counter
	clr	r22
	sts	HOcnt,r22
scan_180HOtableA:
	ld	r22,z+
	sts	SCseg_siz,r22
	;*************************
	;check size
	;*************************
	tst	r22
	breq	scan_180HOtableREADY	;invalid = no direct hosts
	cpi	r22,255
	breq	scan_180HOtableREADY	;invalid = no direct hosts
	;point to the direct host-adress
	ld	r22,z
			;.........................
			;adr=0 ?
			tst	r22
			breq	scan_180HOtableAnxtSEG	;invalid segment = next
			;adr=255
			cpi	r22,0xff
			breq	scan_180HOtableAnxtSEG	;invalid segment = next
			;.........................


	;************************
	;store direct host adress
	;direct count +1
	;************************
	st	y+,r22				;direct host adress
	lds	r22,HOcnt
	inc	r22
	sts	HOcnt,r22
	;************************
	;next segment
	;************************
scan_180HOtableAnxtSEG:
	lds	r22,SCseg_siz
	subi	r22,1
	clr	r23
	add	zl,r22
	adc	zh,r23
	;************************
	;check range
	;************************
	;check limit
	;range ?
	cpi	zl,low(host_tableSHADrange)
	ldi	r23,high(host_tableSHADrange)
	cpc	zh,r23
	brsh	scan_180HOtableREADY
	jmp	scan_180HOtableA

	;*************************
	;return with completed 
	;direct-host collection
	;*************************
scan_180HOtableREADY:
	ret






;*******************************************************************
;scan_190HOtable = transfer the activ host table to concept...
;conditions:
;* spi still in master mode
;* transceiver disabled
;*******************************************************************
scan_190HOtable:
    ;table startadress
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
    clr r22
	sts	SCseg_siz,r22
    rjmp    scan_190HOtableNEWPAY
    ;start there with new payload frame
scan_190HOtableNEWPAY:
	;startadress temp. sram mirror
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
    ;mi: setup/to core
    ldi r22,0b01001000          
    st  y,r22
    ;frame size=17
    ldi r22,17                  
    adiw    yh:yl,5
    st  y+,r22
    ;type = 8
    ldi r22,8                   
    st  y+,r22                  ;yh:yl points to the first payload byte !
    ;
	;clear host counter
	clr	r16
	sts	HOcnt,r16
    ;check hosts in segment
    lds r22,SCseg_siz
    tst r22
    breq    scan_190HOtableA        ;check a new segment...
    rjmp    scan_190HOtableAloop    ;there a still hosts in segment to transmit




    ;start there by checking the segment
scan_190HOtableA:
	ld	r22,z+
	sts	SCseg_siz,r22
	;*************************
	;check size
	;*************************
	tst	r22
	breq	scan_190HOtableREADY	;invalid = no more hosts
	cpi	r22,255
	breq	scan_190HOtableREADY	;invalid = no more hosts
    ;*************************
    ;hosts in segment
    ;(size-1)/2 == host count
    ;*************************
    subi    r22,1       ;-1
    lsr     r22         ;/2    

    ;*****************************
	;load host-adress from seg
    ;*****************************
scan_190HOtableAloop:
	ld	r0,z
    st  y+,r0
    adiw    zh:zl,2                 ;point to the next host adress (independent if direct or meshed!)
    ;payload +1
    inc r16
	sts	HOcnt,r16
    ;host count -1
    subi    r22,1                   ;host count -1
    sts	SCseg_siz,r22
    ;******************************
    ;check the payload counter
    ;******************************
    cpi r16,10
    breq    scan_190HOtableTXCONCEPT    ;frame filled - now transmit ! (return to: scan_190HOtableNEWPAY)
    ;******************************
    ;check for further host in seg
    ;******************************
    tst     r22
    breq    scan_190HOtableA
    rjmp    scan_190HOtableAloop
 



    ;**********************************
    ;no more hosts in table
    ;=> now complete the payload frame
    ;with <0>
    ;**********************************
scan_190HOtableREADY:
    lds r16,HOcnt               ;load payload
    tst r16
    breq    scan_190HOtableBACK ;nothing to transmit

scan_190HOtableREADYloop:
    ;dummy hostadresses
    clr r22
    st  y+,r22
    ;check payload
    inc r16
    cpi r16,10
    breq   scan_190HOtableTXCONCEPT ;now transmit the frame to concept 
    rjmp  scan_190HOtableREADYloop  




    ;**********************************
    ;transmit to concept
    ;**********************************
scan_190HOtableTXCONCEPT:
	;set spi busy...
	lds	r16,comFLAG
	sbr	r16,1<<spiBUSYnet		;1=spi net-data aktiv // cleared by slave init
	sts	comFLAG,r16
    ;
    cbi	portb,_SS
	;first frame_size
	ldi	r22,17
	;set startadress payload
	ldi	yl,low(TE_garbage_seg)
	ldi	yh,high(TE_garbage_seg)
	;set bytecounter
	clr	r17
	;start identifier
    ldi xl,0xd4
	call	_sndPARAspiDO
	;
scan_190HOtableTXCONCEPTLOOP:
	inc	r17
	ld	xl,y+
	call	_sndPARAspiDO
	;now check exit state
	cp	r17,r22
	brsh	scan_190HOtableTXCONCEPTLOOPexit
	rjmp	scan_190HOtableTXCONCEPTLOOP
scan_190HOtableTXCONCEPTLOOPexit:
    sbi	portb,_SS
    jmp scan_190HOtableNEWPAY




    ;************************************
    ;ready done
    ;************************************
scan_190HOtableBACK:
    ret
