;****************************************************************************
;decode rc5-data (rc5INSte) & generate system instruction
;
;INSTRUCTIONS:
;3	=	system power off
;4	=	system power on
;5	=	macro 1  & execute
;...
;14	=	macro 10 & execute

;FORMAT:
;<mi><x><x><x><x><size><type><SadrMSB><SadrLSB><TadrMSB><TadrLSB><data8>...
;****************************************************************************

_sysINST:
    ;rc5-up prfen & ausfhren
	lds		r17,rc5decFL
	sbrs	r17,newINS		;aktuelle rc5 sytem-instruction daten vorhanden?
	rjmp	_sysINSTbk  	;nein !
    ;yes!
    ;check if there's any net-data transfer
    ;running/preparing?
 	lds	 r16,comNETstate
	sbrc r16,comNETnewDATtx		;there is a net-frame to transmit to the spi!
    rjmp  _sysINSTbk            ;no action...
    ;STATErec 2/5?
    lds r18,STATErec
    cpi r18,2
    breq  _sysINSTbk
    cpi r18,5  
    breq  _sysINSTbk  
    ;no transfer preparing
	sbr	r16,1<<comNETnewDATtx		;there is a net-frame to transmit to the spi!
    sts comNETstate,r16
    ;clear flag
    cbr r17,1<<newINS
    sts rc5decFL,r17
    ;make frame   
    lds r16,rc5INSte
    cpi r16,3
    brlo    _sysINSTkill

    ;....................
    ;3= system power off
    cpi r16,3
    brne  _sysINSToff
    ldi zl,low(_systemOFF*2)
    ldi zh,high(_systemOFF*2)
    
    ldi r17,12  ;frame-size
    call   _loadSYSframe 

    rjmp   _sysINSTbk
    ;....................        
                 


                    ;......................
                    ;4= system power on
                    _sysINSToff:  
                        cpi r16,4
                        brne  _sysINSTmac  
                        ldi zl,low(_systemON*2)
                        ldi zh,high(_systemON*2)

                        ldi r17,12  ;frame-size
                        call   _loadSYSframe 

                        rjmp   _sysINSTbk
                    ;.......................




                                ;.........................
                                ;5..14 = system macro
                                _sysINSTmac:  
                                    cpi r16,15
                                    brsh  _sysINSTkill
                                    ldi zl,low(_systemMACRO*2)
                                    ldi zh,high(_systemMACRO*2)
    
                                    ldi r17,17  ;frame-size
                                    call   _loadSYSframe 

                                    ;store macro-number
                                    subi    r16,5
                                    ldi zl,11
                                    clr zh
                                    subi    zl,low(-TX_buffer)
                                    sbci    zh,high(-TX_buffer)
                                    st  z,r16   ;store macro
                                    rjmp   _sysINSTbk
                                ;.........................


  







;.................................................  
;not valid!
_sysINSTkill:
    lds	 r16,comNETstate
	cbr     r16,1<<comNETnewDATtx		;clear
    sts comNETstate,r16
;.................................................


;.................................................
;back...
_sysINSTbk:
	ret
;.................................................







;................................................
;sub loadFRAME
_loadSYSframe:
    ldi yl,low(TX_buffer)
    ldi yh,high(TX_buffer)
    clr xh
    ldi xl,0x60
_loadSYSframeLOOP:
    lpm  r2,z+
    st  y+,r2
    dec r17
    tst r17
    brne  _loadSYSframeLOOP
    ret
