;*******************************************************************************************
;sub textdarstellung
;*******************************************************************************************
;txt-tabellen format inkl. steuerbefehle:
;<maxINDEX(TXTstartadresse+0)>|<scrollDIR(TXTstartadresse+1>|<TEXT(ab TXTstartadresse+2>....|
;<FIELD(0=ende/15=newline)>|<INDEX(255=noINDEX/0-254=INDEX>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;erklrung:
;maxINDEX 	= letzter (Steuer)Index innerhalb des Textfeldes
;DIR		= Scroll Direction 1=Horizontal/0=Vertikal
;TEXT		= Darstellbare ASCII-Codes
;FIELD		= 0    <=>Ende Textfeld
;		  	  15   <=>Neue Zeile
;INDEX		= 255  <=>Kein (Steuer)Index -> Fr Basis-,u.Infotexte 
;		  	  0-254<=>(Steuer)Index      -> Fr Auswahlmens
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;erforderliche variablen beim aufruf(call):
;1)CHARfactorX/Y 	= font-zoomfaktor
;2)TXTstartL/H		= text-startadresse	
;3)txtBOXposX/Yte	= position textbox
;4)graphBOXflTE	= graphik-flags (normal/invers etc....)
;5)upperINDEX		= an oberster/erster stelle gewnschte indexmarke
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
_GtxtMOD:
	;
	;zuerst maxINDEX laden&prfen (aus tabelle)
	ldi	zh,high(patxBUF)
	ldi	zl,low(patxBUF)
	ld	r16,z+	  ;maxINDEX
	sts	maxINDEX,r16  ;store
	ld	r16,z+	  ;scroll direction
	sts	scrollDIR,r16 ;store
	;jetzt beginnt das 
	;eigentliche textfeld
	sts	TXTpointH,zh
	sts	TXTpointL,zl
	;
	;nun Upper-Index laden&prfen - MIT CURSOR-BOX VERNDERBAR
	lds	r16,upperINDEX
	;CHARcounter
	clr	r18
	;suche nun passende index-marke...
_GtxtSEARCHindex:
	ld	r17,z+
	tst	r17
	breq	_Gtxtsign		;textende  ereicht
	cpi	r17,15		;zeilenumbruch...	
	breq	_Gtxtsign
	inc	r18			;CHARcounter
	jmp	_GtxtSEARCHindex
	;prfe indexmarke
_Gtxtsign:
	ld	r17,z+
	cpi	r17,0xff
	breq	_GtxtMODsizeCALC	;255=keine indexmarke
	cp	r16,r17		;nun gewnschte mit aktueller indexmarke vergleichen
	breq	_GtxtINDEXmatch	;gleich !
	clr	r18
	jmp	_GtxtSEARCHindex
	;
_GtxtINDEXmatch:
	;zur upper-indexmarke passenden text
	;adressieren
	;korrektur
	ldi	r17,2
	add	r18,r17
	;
	clr	r17
	sub	zl,r18	;aktuelle adresse - CHARcounter = startTXT
	sbc	zh,r17	;
	sts	TXTpointL,zl
	sts	TXTpointH,zh
	lds	r16,upperINDEX	;erste darzustellende indexmarke...
	sts	downINDEX,r16	;z.zt letzte/unterste indexmarke...
	;index buffer=start
	ldi	r17,high(bufINDEX)
	sts	INDEXpointH,r17
	ldi	r16,low(bufINDEX)
	sts	INDEXpointL,r16
	;
	jmp	_GtxtMODsizeCALC




	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_GtxtMODsizeCALC:
		;
	lds	r16,CHARfactorY	
	ldi	r17,8
	;y-charactersize !
	mul	r16,r17
	sts	yCHARsiz,r0
	;
	call	_CALCpageSIZ	;bentigten x-pagebereich fr txtBOX berechnen
							;& masken erstellen
	;zeichen counter=0
	clr	r16
	sts	CHARcntTE,r16
	;text adressieren
_GtxtMODloop:
	lds	zh,TXTpointH
	lds	zl,TXTpointL
	;character holen
	ld	r16,z+
	sts	TXTpointL,zl	;adresspointer sichern
	sts	TXTpointH,zh
	tst	r16
	breq	_GtxtnewLINE	;text ende
	cpi	r16,15
	breq	_GtxtnewLINE	;cr== new line !!!
	;nun character darstellen
	sts	CHARte,r16
	;charactercounter+1
	;wird fr die berechnung
	;der effektiven gre bentigt
	lds	r16,CHARcntTE
	inc	r16
	sts	CHARcntTE,r16
	;
	jmp	_FLEXfont		;font spaltenweise vergrern & darstellen


	;------------------------------
	;zurck
_GtxtMODready:
	ret
	;------------------------------




	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;indexmarke prfen & ggf.koordinaten
	;in den buffer
	;VERTIKAL / HORIZONTAL !!!
	;new line
_GtxtnewLINE:
	;steuerbefehl sichern	
	mov	r23,r16
	;indexmarke holen
	ld	r16,z+
	;hier aktuelle indexmarke
	;an variable bergeben
	;== grte z.zt. dargestellter index
	sts	downINDEX,r16
	;
	sts	TXTpointL,zl	;adresspointer sichern
	sts	TXTpointH,zh
	cpi	r16,0xff		;255=keine indexmarke gesetzt !	
	breq	_GtxtnewLINEck
	;hier adresspointer-indexbuffer
	;laden...
	lds	zh,INDEXpointH
	lds	zl,INDEXpointL
	;aktuelle indexmarke
	st	z+,r16	;speichern
	lds	r16,graphBOXposXte
	;test
	dec	r16
	st	z+,r16	;speichern
	lds	r16,graphBOXposYte
	;test
	dec	r16
	st	z+,r16	;speichern
	;lnge des feldes berechnen
	ldi	r17,6	;standardbreite
	lds	r16,CHARfactorX
	mul	r16,r17
	mov	r17,r0
	lds	r16,CHARcntTE ;x zeichen pro index
	;
	mul	r16,r17
	mov	r16,r0
	;test
	inc	r16	;+1
	st	z+,r16	;x-size speichern
	lds	r16,yCHARsiz
	;test
	inc	r16
	inc	r16
	st	z+,r16	;y-size speichern
	;neuen adresspointer index-marke
	;sichern
	sts	INDEXpointH,zh
	sts	INDEXpointL,zl
	;prfe ob steuerbefehl =0 (ende) war
_GtxtnewLINEck:
	;char counter =0 (vorbereitung)
;	clr	r16
;	sts	CHARcntTE,r16
	;0=fertig
	tst	r23
	brne	_GtxtSCROLLchk
	jmp	_GtxtMODready








_GtxtSCROLLchk:
	;zuerst scrollrichtung prfen
	;vertikal/horizontal
	lds	r16,scrollDIR
	tst	r16	
	breq	_GtxtVERTI	; 0=vertikal
	jmp	_GtxtHORI	;>0=horizontal
	;
	;++++++++++++++++++++++++++++++++++++++++++++++++
_GtxtVERTI:
	;zuerst prfen ob zeile 
	;im darstellbaren bereich liegt!
	lds	r16,graphBOXposYte
	lds	r17,yCHARsiz
	inc	r17	;+1 zwischenraum
	inc	r17	;+1 zwischenraum
	ldi	r18,2
	mul	r17,r18	;*2
	add	r16,r0	;graphBOXposYte+(2*(yCHARsiz+2))
	cpi	r16,displayLINEmax
	brlo	_GtxtNEWlineOK
	jmp	_GtxtMODready	;passt nicht rein !!!
_GtxtNEWlineOK:
	lds	r16,graphBOXposYte
	lds	r17,yCHARsiz
	inc	r17	;+1 zwischenraum
	inc	r17	;+1 zwischenraum
	add	r16,r17
	sts	graphBOXposYte,r16
	jmp	_GtxtMODsizeCALC
	;
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
_GtxtHORI:
	;zuerst prfen ob spalte 
	;im darstellbaren bereich liegt
	;TEST
	;lnge des feldes berechnen
	ldi	r17,6	;standardbreite
	lds	r16,CHARfactorX
	mul	r16,r17
	mov	r16,r0	;pixel/zeichen
	mov	r19,r0	;sichern
	;anzahl der dargestellten zeichen im index
	lds	r18,graphBOXposXte
	lds	r17,CHARcntTE
	mul	r16,r17	;x zeichen * pixel/zeichen
	add	r18,r0	;neue X position
	;zwischenraum
	;inc	r18
	inc	r18
	;nun ,out of range prfen...'
	mov	r16,r18	;sichern
	add	r16,r19	;neue X-pos + zeichen
	cpi	r16,displayCOLmax ;geht das ganze bers display raus ?
	brlo	_GtxtHORIrangeOK
	;zeilenumbruch
	ldi	r18,3
	sts	graphBOXposXte,r18
	jmp	_GtxtVERTI

	;range OK!
_GtxtHORIrangeOK:
	sts	graphBOXposXte,r18
	jmp	_GtxtMODsizeCALC





	
;******************************************************************************************
;flexible fontdarstellung / vergrerungsfaktor 1-5
;basis: standardfont 6*8 dots
;******************************************************************************************
_FLEXfont:
		;beginne hier mit vergrerung faktor 1-5 (...spter mal grer)
		;daten nach temporren page-variablen (56-bit schieberegister)sichern
		;
	ldi	r17,7
	sts	CNTx,r17
	;
	;set font startadresse
	lds	r16,CHARte		;temporren char laden
	ldi	zh,high(font0x20_lines*2)
	ldi	zl,low(font0x20_lines*2)
	subi	r16,0x20		;es geht bei 0x20 los !
	ldi	r17,6			;standard-bmp x-size
	mul	r16,r17
	add	zl,r0
	adc	zh,r1
	sts	stZpointL,zl		;pointer sichern
	sts	stZpointH,zh		; "        "
	;
	;******************************
	;font-spalten loop
	;******************************
_YfontLOOP:
	lds	r17,CNTx
	dec	r17
	sts	CNTx,r17
	tst	r17
	brne	_YfontLOOPx
	jmp	_GtxtMODloop		;font fertig dargestellt - nchsten character holen++++
	;
	;
_YfontLOOPx:
	lds	zh,stZpointH
	lds	zl,stZpointL
	lpm	r16,z+			;standard font y-spalte holen
	sts	stZpointL,zl		;pointer sichern
	sts	stZpointH,zh		; "        "
	ldi	r18,8			;spalten bit



_PIXcheck:
	lds	r19,CHARfactorY	;vergrerungsfaktor laden
	;pixel<x> der spalte prfen
	;und faktor entsprechend ins schieberegister
	tst	r18
	breq	_COLready	;alle pixel der spalte abgearbeitet
	dec	r18
	;
	lsl	r16
	brcc	_NOdotPLloop	;textbereich durch setzen des befehls ,brcc' !!!
	jmp	_dotPLloop
	

	;plot no pixel
_NOdotPLloop:	
	tst	r19
	breq	_PIXcheck
	dec	r19	;char faktor -1
	clt		;clear t-flag
	call	_SFTregA
	jmp	_NOdotPLloop	

	;plot pixel
_dotPLloop:	
	tst	r19
	breq	_PIXcheck
	dec	r19	;char faktor -1	
	set		;set t-flag
	call	_SFTregA
	jmp	_dotPLloop





;*******************************
;spalte(n) auf display darstellen
;*******************************

;a) shift register inhalt, falls
;   erforderlich verschieben
_COLready:
	lds	r16,SFTfactor	;shift-factor 0-7 laden
_COLreadyLOOP:
	tst	r16
	breq	_COLreadyGO
	clt
	dec	r16
	call	_SFTregA		;x*schieben
	jmp	_COLreadyLOOP





;*******************************************************************************************
;b) *firstPAGE von GLCD adressieren,lesen,maskieren & mit erstem shift-register beschreiben
;   *folgende pages maskieren,adressieren & mit shift-register inhalt beschreiben
;   *lastPAGE von GLCD lesen,maskieren & mit letztem shift-register inhalt beschreiben
;   --> auf display darstellen !
;*******************************************************************************************
 
_COLreadyGO:	
	lds	r25,CHARfactorX	;font x-vergrerungsfaktor
	sts	CHARfactorXte,r25
	;zuerst shift-register ins sram
	;shiftregister startadresse
	ldi	zh,high(SFTregST)
	ldi	zl,low(SFTregST)
	st	z+,r2
	st	z+,r3
	st	z+,r4
	st	z+,r5
	st	z+,r6
	st	z+,r7
	st	z+,r8
	st	z,r9	
_COLreadyREP:
	call	_DRWcolSUB
	;restore x-charfactor
	lds	r25,CHARfactorXte
	dec	r25	;char factor -1
	sts	CHARfactorXte,r25
	tst	r25
	breq	_COLyREADY			;spalte komplett
	jmp	_COLreadyREP		;spalte nochmals schreiben	
_COLyREADY:
	jmp	_YfontLOOP			;nchste spalte des fonts holen








