;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;tables
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;startup configuration & receiver mode after startup !
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;count of instructions= 6
_TXini_tblII:
.dw     TXCONFIGURATION,TXMANAGEMENT,TXCONFIG,DATARATE,FBASE,TXMANAGEMENTgo

_RXini_tblII:
;count of instructions= 9
.dw		RXCONFIGURATION,RXMANAGEMENT,FBASE,DATARATE,RXPARA,RXFILTER,AFCSET,FIFOINI,FIFOENA


;RX
.equ    RXCONFIGURATION     =   0x8057  ;0x8057 = 433MHz // 0x8067 = 868MHz
.equ    RXMANAGEMENT        =   0x82d9
.equ    FBASE               =   0xa6a4
.equ    DATARATE            =   0xc608  ;0xc606 (57,6) 0xc623 (9,6) 0xc608 (38,4)  ;0xc611(19,2)
.equ    RXPARA              =   0x94a0  ;0x9480 bandwith 200KHz // 0x94a0 bandwith 134KHz
.equ    RXFILTER            =   0xc2ac  ;0xc2ac
.equ    AFCSET              =   0xc4f7  ;0xc4f7 = +/- 7,5KHz (once) 0xc497 = +/- 37,5KHz  // 0xc4a7 = +/- 17,5KHz
.equ    FIFOINI             =   0xca81
.equ    FIFOENA             =   0xca83
.equ    DCYCLE              =   0xc80e

;TX
.equ    TXCONFIGURATION     =   0x8097  ;0x8097 = 433MHz // 0x80a7 = 868MHz
.equ    TXMANAGEMENT        =   0x8219
.equ    TXCONFIG            =   0x9810  ;0x9820   = 45KHz deviation // 0x9810 = 30KHz deviation
.equ    TXMANAGEMENTgo      =   0x8239







;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;frequency hopping table (Fstep=
;ch0= 432,5MHz (F=1000) .... ch20=437,5MHz (F=3000)
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
_FREQUhoptbl:
;count of channels = 21
;	432,50	432,75	433,00	433,25	433,50	433,75	434,00	434,25	434,50	434,75	435,00
.dw	0xa3e8,	0xa44c,	0xa4b0,	0xa514,	0xa578,	0xa5dc,	0xa640,	0xa6a4,	0xa708,	0xa76c,	0xa7d0
;	435,25	435,50	435,75	436,00	436,25	436,50	436,75	437,00	437,25	437,50
.dw	0xa834,	0xa898,	0xa8fc,	0xa960,	0xa9c4,	0xaa28,	0xaa8c,	0xaaf0,	0xab54,	0xabb8







;.............................................................................
;constants
;.............................................................................
.equ	_FIFOres		    =	0xca81
.equ	_FIFOena		    =	0xca83
.equ	_READstate		    =	0x0000
.equ	_READfifo		    =	0xb000
.equ	_FIFOsynca		    =	0xb82d
.equ	_FIFOsyncb		    =	0xb8d4
.equ	_TXprae			    =	0xb8aa
.equ	_TXdata			    =	0xb800
.equ    _RECEIVEoffM        =   0x8209  ;8219
.equ    _RECEIVEoffC        =   0x8017  ;0x8017 = 433MHz //0x8027 = 868Mhz





;...............................................................................
;system net instruction frames

_systemOFF:
    .db 24,0xa,0xa,0xa,0xa,12,1,0,0xcc,0,0xcc,0x60


_systemON:
    .db 24,0xa,0xa,0xa,0xa,12,1,0,0xcc,0,0xcc,0x4c


    ;set macro 0..9 to ----------------
_systemMACRO:                        ;|
    .db 24,1,1,1,1,13,1,0,0xca,0,0xca,0x9,0x1,0




