;******************************************************************
;FIXED VERSION 05/08
;- graphical display driver & font-table (5*8dots)
;- integrated radiomodul interface
;- integrated rs485 communication-software
;- for mega644 sysCLK 18,xxMHz
;->have a look at log.asm !
;NOTE: a gnd bridge to display-pin (15)w/r disables the display modules
;******************************************************************
.include "#m644def.inc"
.equ    BOOTSTART = THIRDBOOTSTART
 
;
;hard-wire:						
;PORTA
;pa0...pa7 	== data0...7
;
;PORTB
;pb0		== network busy led
;pb1		== _ifSEL (interface handshake)
;pb2		== _nSEL (select rfm12 /spi)
;pb3		== oc0 (pwm kontrast)
;pb4..7	    == spi (SCK/MISO/MOSI/_SS)
.equ		rfmNET	=	0;
.equ		_IFsel	=	1	;pb1 select HIF/RFM data stream
.equ		_nSEL	=	2	;pb2 select RFM for SPI-Communication
.equ		_SS		=	4	;Enables SPI Transfer (HIF)
.equ		MOSI	=	5
.equ		MISO 	=	6	;MISO Slave output
.equ		SCK		=	7


;PORTC
;pc7  	    == cs1 
;pc6		== cs2
;pc5		== w/r
;pc4		== d/i
;pc3		== e
;pc2		== up/dreh
;pc1		== dw/dreh
;pc0		== push/dreh
.equ	Dpush	    = 	0
.equ	SigA		= 	2	;panasonic enc
.equ	Ddw		    =	2	;old enc.
.equ	SigB		= 	1	;panasonic enc
.equ	Dup		    =	1	;old enc.
.equ	Dena		=	3	;pc3	
.equ	Did		    =	4	;pc4
.equ	Dwr		    =	5	;pc5
.equ	cs1		    =	7	;pc7
.equ	cs2		    =	6	;pc6

;
;PORTD
;pd7		== rc5_fb
;pd6		== alive
;pd5		== oc1a(pwm helligkeit)
;pd4		== RS485 uart direction
;pd3		== prog key
;pd2		== int0 (nriq)
;pd0/1  	== uart
.equ	INT0port		=	2
.equ	progi		    =	3
.equ	uartDIR		    =	4
.equ	STalive		    =	6






;display-flags:
.equ	Dbusy	        =	7	;pa7	;busy-flag		;-
.equ	Don		        =	5	;pa5	;on-flag		;-
.equ	Dres		    =	4	;pa4	;reset-flag		;-
;




;****************************************************************
;definitionen
;****************************************************************
.equ    RAMstart        =   0x100
;mega644 from 0x100
;
.equ	graphFU		    =	0x100	;graphische funktionsvariable
.equ	graphFUte		=	0x101	;temp. graph. variable
.equ	GsymFL		    =	0x102	;gsym steuerflag
.equ	GsymTIAl		=   0x103	;lower byte dyn.timerA
.equ	GsymTIAh		=	0x104	;higher byte dyn.timerA
.equ	GsymTIBl		=   0x105	;lower byte dyn.timerB
.equ	GsymTIBh		=	0x106	;higher byte dyn.timerB
.equ	GsftTIl		    =	0x107	;lower byte shift timer
.equ	GsftTIh		    =	0x108	;higher byte shift timer
.equ	Xshift		    =	0x109	;shift faktor (xpos+xshift)=aktuelle pos
.equ	SYMxSIZE		=	0x10a	;real xsize variable
.equ	SYMyBYTE		=	0x10b	;real ybyte variable
.equ	SYMhlp		    =	0x10c
.equ	symZpointL	    =	0x10d
.equ	symZpointH	    =	0x10e
.equ	symZpointLte	=	0x10f
.equ	symZpointHte	=	0x110

;backlight
.equ	NORMlight		=	0x111	;normal helligkeit
.equ	DIMlight		=	0x112	;dim helligkeit
.equ	DIMcntaL		=	0x113	;dimm counter 1 low
.equ	DIMcntaH		=	0x114	;               high
.equ	DIMcntbL		=	0x115	;dimm counter 2 low
.equ	DIMcntbH		=	0x116	;               high
.equ	DIMflag		    =	0x117	;dimm flags

;flags
.equ	BLred		    =	0		;reduziere backlight
.equ	BLnorm		    =	1		;normaler backlight wert
.equ    BLdim           =   2       ;dim sequence

;rc5 decoder
.equ	rc5decFL		=	0x118	;decFLAG
.equ	rc5state		=	0x119	;rc5state
.equ	rc5bistate	    =	0x11a	;biSTEP
.equ	rc5adress		=	0x11b	;rc5 adresse
.equ	rc5data		    =	0x11c	;rc5 daten	
.equ	rc5dataTE		=	0x11d	;temp.rc5 daten
.equ	rc5freeCNT	    =	0x11e	;freecoder counter
.equ	rc5adressTE	    =	0x11f	;adressbk
.equ	rc5datPRbk	    =	0x120
.equ	rc5codeREPa	    =	0x121	;repeatcounters

;encoder 
.equ	countRIGHT	    =	0x122
.equ	countLEFT		=	0x123


;konstanten
.equ	rc5repA		    =	0x1 	;.3rep
.equ	rc5repB		    =	0xd 	;2sec


;rc5 flags
.equ	toggle		    =	0
.equ	compl		    =	1
.equ	learnX		    =	2
.equ	toggleBK	    =	3
.equ    newINS          =   4       ;new system instruction



;boot counter;.......................................................
.equ	bootACNTl		=	0x124	;boot Acnt L
.equ	bootACNTh		=	0x125	;boot Acnt H
.equ	bootBCNTl		=	0x126	;boot Bcnt L
.equ	bootBCNTh		=	0x127   	;boot Bcnt H


;.....................................................
;flags (GsymFL)
.equ	showSYM	  	    =	0	;symbol darstellen (aus sysIF)
.equ	dynSYM		    =	1   ;dynamische symboldarstellung
.equ	sftSYM		    =	2	;symbol verschieben
.equ	newSYM		    =	3	;neues symbol darstellen
;.....................................................
;konstanten
.equ	ySYM		    =	4	;4 bytes pro spalte
.equ	xSYM		    =	35	;36 spalten (0...35)
.equ	sftTIME	        =	10000   ;40000
.equ	symLARGE	    =	144
;
.equ	bootCT		    =	65535
.equ	bootEND		    =	30	


;konstanten
.equ	DcntA		    =	65534
.equ	DcntB		    =	16
;	
.equ    DcntAdim        =   514
.equ    DcntBdim        =   255   ;dim time

;info: produkt DnctA*DcntB=  (runtime ca.19sekunden)


;auswahl variablen
.equ	tempAUSmain	    =	0x128	;temp.auswahl
.equ	tempAUSsub	    =	0x129	;temp.auswahl
;variablen:
.equ	TXTpointL		=	0x12a		;txt-adresspointer LOW
.equ	TXTpointH		=	0x12b		;txt-adresspointer HIGH
.equ	CHARte		    =	0x12c		;temporrer character

;temporre positionsvariablen f. graphische elemente
.equ	curMODflTE	    =	0x12d	;cursor flagvariable
.equ	graphBOXflTE	=	0x12e	;graphic flagvariable
;
.equ	graphBOXposXte	=	0x12f
.equ	graphBOXposYte	=	0x130
.equ	graphBOXsizXte	=	0x131
.equ	graphBOXsizYte	=	0x132
.equ	xPOSabs		    =	0x133	;absolute x-position
.equ	yPOSabs		    =	0x134	;absolute y-position
.equ	xPAGEpos		=	0x135	;x-page position
.equ	xCHARsiz		=	0x136	;char x-size
.equ	yCHARsiz		=	0x137	;char y-size
;
.equ	stZpointL		=	0x138	;z-pointer l
.equ	stZpointH		=	0x139	;z-pointer h
.equ	stYpointL		=	0x13a	;y-pointer l
.equ	stYpointH		=	0x13b	;y-pointer h
;	
.equ	CNTx			=	0x13c	;x-pixel counter
.equ	CNTy			=	0x13d	;y-pixel counter	
.equ	radCIRCLE		=	0x13e	;radius circle
.equ	xPLOT		    =	0x13f	;x-punkt
.equ	yPLOT		    =	0x140	;y-punkt
.equ	radCNT		    =	0x141	;winkelberechnungsvariable
.equ	lgtLINE     	= 	0x142	;relative linienlnge
.equ	alphaLINE   	= 	0x143	;linienwinkel (30' schritte)
.equ	quadLINEfl  	= 	0x144	;flagvariable (plotquadrant)
.equ	lgtLINEte		=	0x145	;temp.relative linienlnge
;
.equ	paraA		    =	0x146	;parameter A (bargraph...)
.equ	paraB		    =	0x147	;parameter B	
.equ	paraC		    =	0x148	;parameter C
.equ	paraD		    =	0x149	;parameter D
.equ	paraE		    =	0x14a	;parameter E
.equ	paraF		    =	0x14b	;parameter F
.equ	paraG		    =	0x14c	;parameter G
.equ	paraH		    =	0x14d	;parameter H
;
;temporre text-,u. Cursorvariablen 
.equ	maxINDEX		=	0x14e	;max. anzahl von indexmarken innerhalb eines auswahlfeldes
.equ	upperINDEX	    =	0x14f	;DISPLAY-an oberster/erster stelle gewnschte indexmarke
.equ	lastINDEX		=	0x150	;DISPLAY-an unterster/letzter stelle stehende indexmarke
.equ	scrollDIR		=	0x151	;anzeigerichtung vertikal/horizontal
.equ	TXTstartL		=	0x152	;text startadresse Low-byte
.equ	TXTstartH		=	0x153	;text startadresse High-byte
.equ	CHARcntTE		=	0x154	;temporrer character-counter
.equ	downINDEX		=	0x155	;temporre indexmarke
.equ	INDEXpointL	    =	0x156	;dynamischer index-adresspointer Low-byte
.equ	INDEXpointH 	=	0x157	; "                         "    High-byte
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	comBUFadrL	    =	0x158	;buffer adresse L
.equ	comBUFadrH	    =  	0x159	;buffer adresse H
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	comFLAG		    =	0x15a	;kommunikation flag-variable
;-> flags (comFLAG)
.equ	newHIFdata	    =	0		;new HIF-data in buffer - flag
.equ	spiBUSYhif	    =	1		;HIF datenbertragung aktiv (RX/TX)
.equ	newHIFtx	    =	2		;new HIF-data to send
.equ    waitHIFdata     =   3       ;wait for hif-data from system after transmitting index... 
.equ    spiBUSYnet      =   4       ;NET datenbetragung aktiv (RX/TX)
.equ    newNETdata      =   5       ;new received NET-data in buffer
.equ    spiBUSYerr      =   6       ;spi receives invalid data...
.equ    RFMbusy         =   7       ;rfm-h_if communication busy

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	paraFUNC		=	0x15b	;parameter funktions-flagvariable	
;-> flags (graphFUNC)
.equ	numG			=	5		;numerische darstellung
.equ	parG 		    =	6		;parameter
.equ	barG 		    =	4		;bargraph
.equ	ediG 		    =	7		;parameter editieren
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	cntPAR		    =	0x15c	;anzahl der bertragenen parameter
.equ	cntPARte		=	0x15d	;"                "
.equ	tePAR		    =	0x15e	;temp. parameter
.equ	tePARx		    =	0x15f	;"        "
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	TURNcnt		    =	0x160	;drehratenwert 
.equ	CURindex		=	0x161	;cursor index
.equ	turnDWnew		=	0x162	;
.equ	turnDWold		=	0x163	;
.equ	curBOXaktX	    =	0x164	;aktuelle cursor koordinaten
.equ	curBOXaktY	    =	0x165	;"
.equ	curSIZaktX	    =	0x166	;"
.equ	curSIZaktY	    =	0x167	;"
.equ	curLINEakt	    =	0x168	;"
;
.equ	paraMIN		    =	0x169
.equ	paraMAX		    =	0x16a
.equ	paraPOS		    =	0x16b
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;spi
.equ	spiDATctIST	    =	0x16c
.equ	spiDATctSOLL	=	0x16d
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;temp. hilfsvariablen
.equ	helpA		    =	0x16e
.equ    DIMlightTE      =   0x16f


.equ	SFTregST		=	0x170	;startadresse 56-bit schieberegister 0x170 bis 0x179 (reserve..)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;index-buffer 0x17a - 0x279
.equ	bufINDEX		=	0x17a		;indexbuffer startadresse (size 0xff)   
.equ    bufINDEXend     =   0x279       ;limit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;text/parameter buffer 0x27a - 0x40a
.equ	patxBUF		    =	0x27a		;parameter / text startadresse (size 0x400 bytes)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;kommunikation if-buffer 0x40b - 0x46f
.equ	comBUF		    =	0x40b		;kommunikation if-buffer startadresse (0x64 bytes)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;aktiv-parameter-buffer 0x470 - 0x4d4
.equ	paraACT		    =	0x470		;aktive parameter (max. 15 parameter inkl.min/max) size 0x64 bytes
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;neue variablen fr flexible
;fontdarstellung & positionierung

;a) page-berechnung (basis: txtBOXpos0y + yCHARsize) 
.equ	firstPAGEmask	    =	0x4d5	;erste page mask innerhalb des bereichs
.equ  lastPAGEmask	        =	0x4d6	;letzte page mask innerhalb des bereichs
.equ	cntPAGE		        =	0x4d7	;page counter
.equ	firstPAGE		    =	0x4d8	;(#)first page
.equ	lastPAGE		    =	0x4d9	;(#)last page
.equ	effPAGErange	    =	0x4da	;(#)effective page-range 1-8
.equ	SFTfactor		    =	0x4db	;(#)shift factor
.equ	CHARfactorX	        =	0x4dc	;(#)X-char vergrerungsfaktor
.equ	CHARfactorXte	    =	0x4dd	;(#)X-char vergr. temp
.equ	CHARfactorY	        =	0x4de	;(#)Y-char vergrerungsfaktor
.equ	LINEth		        =	0x4df	;(#)linienstrke graph-mode
;


;*******************************************************************************
;****************************************************************

;flags zu <quadLINEfl>:
.equ	PxMy	     	    = 	0	;quadrant rechts oben (+x,-y)
.equ	PxPy	    		= 	1	;quadrant rechts unten(+x,+y)
.equ	MxPy	    		= 	2	;quadrant links unten (-x,+y)
.equ	MxMy	    		= 	3	;quadrant links oben  (-x,-y)
;
;flags <graphBOXflTE>:
;
.equ	graphBOXfull		=	0	;graph-box full (0=ergnzen / 1= berschreiben)
.equ	graphBOXready		=	1	;graph-box ready
;.equ	graphBOXcursor	    =	2	;graph-box menu-cursor aktiv
.equ	graphBOXpara		=	3	;graph-box parameter darstellung (aus sram)
.equ	graphBOXclr		    =	4	;graph-box rahmen clear
.equ	graphBOXbar		    =	5	;graph-box bargraph
.equ	graphBOXcont		=	6	;graph-box contour (rahmen)
.equ	graphBOXinv		    =	7	;graph-box invertieren

;***************************************************************
;flags <curMODflTE>:
;
.equ	curEDIT		    =	0	;edit mode aktiv
.equ	SigABK		    =	1	;letzter drehratenstatus sigA
.equ	SigBBK		    =	2	; "                      sigB
.equ	curINIT		    =	3	;cursor initialisiert		
.equ	BOXcursor		=	4	;menu-cursor enabled
.equ	BOXactiv		=	5	;cursor aktiv
.equ	puHIGH		    =	6	;letzter push status
.equ	sigBstable	    =	7	;aktueller encoder status

;
;mask:
;ACHTUNG: nach adressierung ein dummy-read erforderlich !
;a) write instructions
;- D/I = 0 
;- W/R = 0
;
.equ	IdisON		    =	0x3f	;instruktion display ON
.equ	IdisOFF		    =	0x3e	;instruktion display OFF
.equ	IpageADR		=	0xb8	;instruktion set x-page adress 0 (add 1-7 for following pages!)
.equ	IyADR		    =	0x40	;instruktion set y-line adress 0 (add 1-63 for following lines!)
.equ	IstLINE		    =	0xc0	;instruktion set display start-line 0 (add 1-63 for following lines!
.equ	IleftYpage	    =	0x40	;d/i,w/r,cs1,cs2 mask for left y-page	
.equ	IrightYpage 	=	0x80	; "          "        "   right y-page
;
;b) write data
;- D/I =1
;- W/R =0
;
;c) read instructions
;- D/I =0 
;- W/R =1
;
;d) read data
;- D/I =1
;- W/R =1
;
;*************************************************************
;
;*************************************************************
;system-basics:
.equ	displayPAGEmax		=	8	;page 0-7 (8pages*8dots=64)
.equ	displayCOLmax		=	128	;spalte 0-127 	
.equ	displayLINEmax		=	displayPAGEmax * 8



;.....................................................................................
;RFM12 INTEGRATION
;.....................................................................................
;used memory space for rfm12
;from 0x4e0
;------------------------------------------------------------------------------------------------------	
;ram variable
.equ	rfm12_instr		    =	0x4e0
.equ	Shost_adr			=	0x4e1
.equ	Thost_adr			=	0x4e2
.equ	T2host_adr		    =	0x4e3
.equ	rfQUAL			    =	0x4e4
.equ	Qfactor			    =	0x4e5		;Qualityfactor
.equ	RX_Data			    =	0x4e6		;receive data
.equ	TX_DATA			    =	0x4e7		;tramit data
.equ	FRAME_siz			=	0x4e8		;frame size
.equ	TRANS_state		    =	0x4e9		;transceiver state
.equ	rxCKsumREC	    	=	0x4ea		;rx checksum 
.equ	rxCKsumBUILT		=	0x4eb		;tx checksum 
.equ	txCKsum			    =	0x4ec		;rx checksum 
.equ	TXrepCNT			=	0x4ed		;tx repeat counter
.equ	HscanCNT			=	0x4ee
;help var
.equ	CNTa				=	0x4ef		;temporary counter
.equ	CNTb				=	0x4f0		;temporary counter
.equ	CNTc				=	0x4f1		;temporary counter
.equ	CNTd				=	0x4f2		;temporary counter
.equ	CNTe				=	0x4f3		;temporary counter
;timeout counter
.equ	CNTtioutL			=	0x4f4		;timeout counter low
.equ	CNTtioutH			=	0x4f5		;timeout counter high
.equ	CNTtimerL			=	0x4f6		;ms timer low
.equ	CNTtimerH			=	0x4f7		;ms timer high
;timer control
.equ	timerCONTR		    =	0x4f8		;timer control flags
;table pointer
.equ	HtablePOSl		    =	0x4f9		;table posizion low
.equ	HtablePOSh		    =	0x4fa		;table posizion high
.equ	tSEG_siz			=	0x4fb		;temp. segment-size
.equ	SCtablePOSl		    =	0x4fc		;scan table posizion low
.equ	SCtablePOSh		    =	0x4fd		;scan table posizion high
.equ	SCseg_siz			=	0x4fe		;scan segment size
;host adress
.equ	OLDShost_adr		=	0x4ff		;OLD source adress
.equ	DIRhost			    =	0x500		;direct host
.equ	DIRhostREC		    =	0x501		;received direct host (the source adress in a received frame !)
;state var
.equ	STATEsend			=	0x502		;transmit state (the value is equal to the mode instruction)
.equ	STATEsendTE		    =	0x503		;temporary transmit state (the value is equal to the mode instruction)
.equ	STATErec			=	0x504		;receive state (the value is equal to the mode instruction)
.equ	STATEreq			=	0x505		;requested (receive) state (the value is equal to the mode instruction)
.equ	STATErecTE	    	=	0x506		;temp. receive state (the value is equal to the mode instruction)
;stackpointer
.equ	comNETstackPOINT    =	0x507		;stackpointer
;buffer pointer
.equ	TXbufPOINTl	    	=	0x508		;tx_buffer pointer LOW
.equ	TXbufPOINTh		    =	0x509		;tx_buffer pointer HIGH
;uart
.equ	tFRAME_siz		    =	0x50a		;temporary frame-size
;byte counter
.equ	RECbyte			    =	0x50b		;received bytes
.equ	TRANSbyte			=	0x50c		;transmitted bytes
;serCOM mi
.equ	serCOMmi			=	0x50d
;rfm
.equ	RXch				=	0x50e		;rx channel
.equ	TXch				=	0x50f		;tx channel
.equ	toMSB			    =	0x510		;MSB to slave
.equ	fromMSB		    	=	0x511		;MSB from slave
.equ	toLSB			    =	0x512		;LSB to slave
.equ	fromLSB			    =	0x513		;LSB from slave
.equ	DIRhostSCAN		    =	0x514		;scanned direct host
.equ	fifoSTART			=	0x515       ;fifo start pointer
.equ	fifoEND			    =	0x516       ;fifo end pointer
.equ	HOcnt		    	=	0x517		;host counter (broadcast)
;fifo-state flags
.equ	fifoVAR			    =	0x518		;fifo-state
;fifo  pointer
.equ	fifoIN			    =	0x519		;fifo in pointer
.equ	fifoOUT			    =	0x51a		;fifo out start-pointer
;comNET-state
.equ	comNETstate	    	=	0x51b
;stack
.equ    comNETpointH        =   0x51c       ;VAR: MSB of bufferpointer
.equ    comNETpointL        =   0x51d       ;VAR: LSB of bufferpointer
.equ    comNETpointSH       =   0x51e       ;VAR: MSB of bufferpointer START
.equ    comNETpointSL       =   0x51f       ;VAR: LSB of bufferpointer START
;rfm-communication TX state flags
.equ	COMTXstate		    =	0x520		;com state
;rc5 dat temp
.equ   rc5INSte             =	0x521		;temp.rc5 instr.
;_ifSEL detect flags
.equ	ifSELstate		    =	0x522		;_ifsel state
;rfm receiver off counter
.equ	rfmRECcntL		    =	0x523
.equ	rfmRECcntH		    =	0x524
;temp. spi data
.equ	paraMAXte			=	0x525
.equ	curINDEXte		    =	0x526
.equ	paraFUNCte		    =	0x527
.equ	paraMINte			=	0x528
.equ	paraAte			    =	0x529
.equ	paraPOSte			=	0x52a
;rs485 flags
.equ	RS485state		    =	0x52b		;rs485 states
;wait for free counter
.equ	RS485scan			=	0x52c		;wait counter
;fifo segment size
.equ    fifoSEG             =   0x52d       ;fifo segment size
;led on counter
.equ    LEDtime             =   0x52e
;status rfm
.equ    stateMSB            =   0x52f
.equ    stateLSB            =   0x530
;request data timeout 220s* REQtiout
;.equ    REQtiOUT            =   0x531
;stack
.equ    comNETsegCNT        =   0x532       ;stack segment counter
.equ    comNETstackFL       =   0x533       ;FLAG-VAR
.equ    comNETstackCNT      =   0x534       ;VAR: count of active stack items
.equ    comNETstackSTA      =   0x535       ;VAR: stack startpoint
.equ    comNETstPOINTH      =   0x536       ;VAR: MSB of stackpointer
.equ    comNETstPOINTL      =   0x537       ;VAR: LSB of stackpointer
;stacksegment items
.equ    comNETskITstH       =   0x538       ;VAR: MSB of startadress in stacksegment
.equ    comNETskITstL       =   0x539       ;VAR: LSB
.equ    comNETskITedH       =   0x53a       ;VAR: MSB of endadress in stacksegment
.equ    comNETskITedL       =   0x53b       ;VAR: LSB
;rfm
.equ    rfmFRAMEist         =   0x53c       ;temp.VAR: ist count of active data bytes
.equ    rfmFRAMEsoll        =   0x53d       ;temp.VAR: soll count of active data bytes
.equ    rfmFRAMEteins       =   0x53e       ;temp. instruction
;rs485
.equ    rs485FIFOpoint      =   0x53f       ;fifo pointer
.equ    rs485RECsize        =   0x540       ;rec framesize
.equ    rs485ckSUM          =   0x541       ;checksum
;system config
.equ    HIFGLOB             =   0x542       ;transceiver
;remote
.equ    REMif               =   0x543       ;remote flags 
;.equ    REMifCLIENT         =   0x544       ;remote flags client
.equ    REMmaster           =   0x545       ;master adress
.equ    REMslave            =   0x546       ;slave adress
.equ    REMtype             =   0x547       ;remote data-type
.equ    REMsize             =   0x548       ;data size
.equ    REMtypeTE           =   0x549       ;temporary rem type
.equ    REMsizeTE           =   0x54a       ;temporary data size
;request data timeout 220s* REQtiout
.equ    REQtiOUTl           =   0x54b       ;lsb counter
.equ    REQtiOUTh           =   0x54c       ;msb counter
;manchester codec
.equ    MANstate            =   0x54d       ;manchester state
.equ    RECmanTE            =   0x54e       ;temporary byte


;........................................................................................
;storage buffers & segments
;........................................................................................
;startadress ack-buffer
.equ	ack_buffer		    =	0x550		;acknowledge buffer 10bytes (0x550-0x559)
;net communication buffer segment 
.equ	comNETbuffer		=	0x55a		;comNETBUF net-data buffer 
.equ	comNETBUFSIZE		=	0x1ff		;comNETBUF net-data buffer size = 0x1ff
.equ	comNETbufferEND		=	0x759		;comNETBUF net-data buffer range
;com net stack
.equ    comNETstack         =   0x75a       ;startadress
.equ    comNETstackEND      =   0x7aa       ;2*(+ 4 (start MSB/LSB , end MSB/LSB) * 10 stackpoints)
;startadress rfm-buffer
.equ	rfm_buffer		    =	0x7ab		;rfm-buffer startadress (0x7ab- 0x8aa)
.equ	rfm_buffer_siz		=	0xff		;size = 255 bytes
;actual tx data to rfm
.equ    RFMtxbuffer         =   0x8ab       ;for pointer <comBUFdynPOINT>
.equ    RFMtxbufferLIM      =   0x9aa       ;size = 255 bytes
;startadress tx-buffer
.equ	tx_buffer			=	0x9ab		;tx-buffer startadress (0x8ab - 0x9aa)
.equ	tx_buffer_siz		=	0xff		;size = 255 bytes
;fifo-storage segment
.equ	fifoSEGrx			=	0xaab		;rfm fifo buffer 
.equ	fifoSEGrxSIZE		=	0xff		;rfm fifo buffer size = 0xff
.equ	fifoSEGrxRANGE		=	0xbaa		;rfm fifo buffer range
;rs485 buffer
.equ	rs485NETbuffer		=	0xbab		;rs485 comNETBUF net-data buffer 
.equ	rs485NETBUFSIZE		=	0xff		;size = 0xff
.equ	rs485NETbufferEND	=	0xcaa		;buffer range
;startadress shadow-buffer
.equ	host_tableSHAD		=	0xcab		;shadow-startadress 
.equ	host_tableSHADrange	=	0xeaa		;end 512bytes
;temp. garbage segment
.equ	TE_garbage_seg		=	0xeab		;garbage segmentstart
.equ	TE_garbage_segRANGE	=	0x10aa      ;size = 512 bytes


;.....................................................................................
;end of var-sram seg
.equ    VARend              =   0x10ab
;.....................................................................................


;.....................................................................................
;e2p storage
;.....................................................................................
;host adress (e2p)
.equ	host_adress_e2p	    =	0x5ff
;startadress host-table (e2p)
.equ	host_table		    =	0x600			;host-adress table start (0x600)
.equ	host_table_range	=	0x7ff			;end.512 bytes



;-------------------------------------------------------------------------------------
;constants
;-------------------------------------------------------------------------------------
.equ	clock_f		    	=	18432000				
.equ	uart_baudrate		=    112500						;
.equ	SETbaud		    	= 	(clock_f/(16*uart_baudrate))-1	;
.equ	msVAL			    =	(clock_f/1000)-9
;.equ	rx_tiout			=	1				;1ms
.equ	TXrep			    =	4				;1 repeats tx-data up to <TXrep>-times
.equ	rfmRECoff			=	2		    	;2 (1/rfmBAUD)*8
.equ    rfmRECoffMF         =   8               ;8 mailfunction counter
.equ	RS485scanSET		=	5			    ;wait constant
.equ    REQtiOUTk           =   300             ;250
.equ    REQtiOUTkREM        =   600             ;600

;........................................................................................
;flags & bit definition
;........................................................................................

;-------------------------------------------------------------------------------------------------------
;uart flags <TRANS_state>
.equ	nRFirqEV			=	2		;nIRQ event
.equ	nRF_RXrun			=	3		;receive active
.equ    nRF_RXreq           =   4       ;activate receiver next !
;-------------------------------------------------------------------------------------------------------
;mi (serCOM)
.equ	b_cast			    =	7		;broadcast=0 / no broadcast=1
.equ	if_setup			=	6		;Interface setup =1 
.equ	request			    =	5		;request=1 / no request =0
;-------------------------------------------------------------------------------------------------------
;flags <timerCONTR>	
;.equ	msTIMreach		    =	0		;target value reached
.equ	TIMrun			    =	1		;enables the timer
.equ	TIMstart			=	2		;starts the timeout counter
;------------------------------------------------------------------------------------------------------
;flags
.equ	dqd				    =	7		;(in LSB status read)data quality flag
.equ    ffov                =   5       ;(in MSB status read)fifo overflow
;------------------------------------------------------------------------------------------------------	
;<comNETstackFL>
.equ    STACKupdate         =   0           ;one OLD stacksegment updated
.equ    STACKupCARRY        =   1           ;stack segment contains a frame that is stored with buffer carry !
.equ    STACKempty          =   2
.equ    STACKrebuild        =   3           ;spi receive routine is going to rebuild the stack items
;<rs485 state>
.equ	RS485busy			=	0			;busy
.equ	RS485to			    =	1			;tx to rs485
.equ	RS485from			=	2			;rx from rs 485
.equ	RS485wait			=	3			;wait cycles till free...
.equ    RS485ena            =   4           ;rs485 enabled
;<ifSELstate>
.equ	ifSELlast			=	0
.equ	ifSELrun			=	1
;<COMTXstate>
.equ	RFMbufFILL		    =	0			;rfm buffer filled with data 
.equ	RFMtxSTART		    =	1			;rfm buffer transmitting started
.equ	RFMtxRUN			=	2			;rfm buffer transmitting runs
.equ	RFMtxSTOP			=	3			;rfm buffer transmitting finishing
.equ    BUFsecure           =   4           ;don't load new data to <RFMtxbuffer> if=1
;<comNETstate>
.equ    comNETready         =   0           ;segment ready filled
.equ    comNETcarry         =   1           ;segment stored with buffer carry !.equ	comNETreadA 		=	2			;tells _SPIint - dynamic reading segment A... don't destroy !
.equ	comNETnewDATtx		=	6			;tx new data in buffer !
;<fifoVAR>
.equ	fifoNEW			    =	0			;new data in fifo flag
.equ	fifoTIOUT			=	2			;fifo timeout
;<HIFGLOB>
.equ    rfmENA              =   0           ;1=rfm enabled
.equ    disENA              =   1           ;1=display enabled
;<REMif>
.equ    REMon               =   0           ;remote on
;.equ    REMgoOFF            =   1           ;remote shutdown
.equ    REMstate            =   2           ;remote 1=master / 0=slave
.equ    REMoff              =   3           ;remote off
;.equ    REMgetDIS           =   4           ;get display data
;.equ    REMsendCON          =   5           ;transmit controller data
.equ    REMtog              =     6          ;toggle bit for request time
;<REMtype>
.equ    REMinstr            =   0xa8        ;tx/rx remote-intruction WITHOUT data // fixed framesize=8
.equ    REMdisDAT           =   0xa9        ;tx/rx remote-data to display
.equ    REMconDAT           =   0xaa        ;tx/rx remote-data from encoder to excecute
;<MANstate>
.equ    MANnibble           =   0           ;0=lower nibble





;*************************************************************************************	
;interrupt vectors
;*************************************************************************************
.cseg
.org    0
	jmp	_initSYS	;nach auftstarten...
;nIRQ Service via INT0
.org    0x2	
	jmp	nIRQ_SVR			
; Overflow2 Interrupt Vector Address
.org	0x16		;timer2 ov-interrupt 222s !
	jmp	comSTATE
;SPI-interrupt 0x26
.org	0x26
	jmp	_SPIslave	
;UART Receive complete
.org    0x28
	jmp	Suart_SVR	
	

;.....................................................................................
;system start ...
;.....................................................................................
.org	0x38
	;system init
_initSYS:   
	;stack-range
	ldi	r16,high(ramend)
	out	sph,r16
	ldi	r16,low(ramend)
	out	spl,r16
    ldi zl,low(SRAM_START)
    ldi zh,high(SRAM_START)
    clr r16
_CLRram:
    st  z,r16
    cpi zl,low(VARend)
    ldi yh,high(VARend)
    cpc zh,yh
    breq    _CLRready
    adiw    zh:zl,1
    rjmp  _CLRram  



_CLRready:
	;set rfmNET output low
	cbi	portb,rfmNET
	sbi	ddrb,rfmNET

	;+++++++++++++++++++++++++++++++++++++++++++
	;PORTA-setting (displaydata new)
	ldi	r16,0
	out	ddra,r16	;data 0-7 (default=input)
	out	porta,r16
	;+++++++++++++++++++++++++++++++++++++++++++



	;+++++++++++++++++++++++++++++++++++++++++++
	;PORTB-settings
  	;+++++++++++++++++++++++++++++++++++++++++++ 
    sbi portb,pb3
    sbi ddrb,pb3
	;set _SS input
	sbi	portb,_SS
	cbi	ddrb,_SS
	;set _nSEL output
	sbi	portb,_nSEL
	sbi	ddrb,_nSEL
	;set _ifSEL input
	sbi	portb,_ifSEL
	cbi	ddrb,_ifSEL
	;set miso input
	sbi	portb,MISO
	cbi	ddrb,MISO
	;set mosi input
	sbi	portb,MOSI
	cbi	ddrb,MOSI
	;set mosi input
	sbi	portb,SCK
	cbi	ddrb,SCK
	;set rfmNET output high
	sbi	portb,rfmNET
	sbi	ddrb,rfmNET
    ;INTport0 input
    sbi portd,INT0port
    cbi ddrd,INT0port 
 


    ;...............................
    ;check if a display's on board !
    cbi     ddrc,Dwr
    sbi     portc,Dwr
    clr     r16
    sbr     r16,1<<disENA
    sbic    pinc,Dwr
    rjmp    _INITgo
    ;gnd bridge via resistor 
    ;to Dwr (Pin15) while POR !
    ;== display off
    cbr     r16,1<<disENA
_INITgo:
    sts hifGLOB,r16
    ;................................



	;+++++++++++++++++++++++++++++++++++++++++++
	;PORTC-setting (display control & dreh)
	ldi	r16,0xf8	;0-2 input(dreh),3-7 output (control)
	out	ddrc,r16	
	ldi	r16,0x2f	;e & w/r high // encoder high in
	out	portc,r16
	;+++++++++++++++++++++++++++++++++++++++++++

	;+++++++++++++++++++++++++++++++++++++++++++
	;PORTD-setting
	ldi	r16,0x30	;oldx60
	out	ddrd,r16
	ldi	r16,0xcc	;oldx80	;
	out	portd,r16

	;*******************************************
	;uart baudrate 
	;*******************************************
	ldi	r16,high(SETbaud)
	sts	ubrr0h,r16
	ldi	r16,low(SETbaud)		;baud konst. laden
	sts	ubrr0l,r16


  


	;*******************************************
	;external Interrupt 
	;*******************************************
	ldi	r16,0b00000010	;0b00000010	
	sts	eicra,r16		;INT0 low edge triggered
	ldi	r16,0b00000001	
	out	eimsk,r16		;INT0 enabled


	;******************************************************************
	;timer2 overflow-interrupt alle 222s
	;Fclk(18432000MHz)/64=288000Hz/64=4500Hz <=> 1/4500Hz = 222s
	;******************************************************************
	.equ	tiREL	=	193
	;tiREL=(256+1)-64 = 193
	clr	r16
	sbr	r16,1<<toie2	;enable overflow interrupt
	sts	timsk2,r16
	clr	r16
	sbr	r16,1<<cs22
	sts	tccr2b,r16	;prescale /64
	
	ldi	r16,tiREL		;s reload 
	sts	tcnt2,r16


    ;........................................
	;check system state...
    lds     r16,hifGLOB
    sbrs     r16,disENA
    rjmp     _INITgoB               ;display disabled
    ;........................................

	;
	;*******************************************************************
	;pwm defaults
	;a) timer0 (8bit)
	;tccr0
	;wgm00=1 & wgm01 =1 ;fast pwm
	;com00=0 & com01 =1 ;clear oc0 on compare match / set on top
	;cs00 =0 & cs01  =1 & cs02 =0 ;flck/8
	;tcnt0=0
	;ocr0 =0-255 (pulsw.)
	;*******************************************************************
	;
	clr	r16
	sbr	r16,1<<com0A1
	cbr	r16,1<<com0A0
	sbr	r16,1<<wgm00
	sbr	r16,1<<wgm01
	out	tccr0a,r16
	;
	clr	r16
	sbr	r16,1<<cs00
 ;   sbr r16,1<<wgm02    ;TEST
	out	tccr0b,r16
	;
	ldi	r16,0
	out	tcnt0,r16
	ldi	r16,19	;pwm pulsweite  20=-3,5V|35 =-3,7V|45 =-3,8V|50=-3,8V|100=-3.5V|150=-3,2V|200=-2,7V
				;              220=-2,4V|235=-2,3V|245=-1,9V|250=-1V |253=+0,7V|254=+1V | /fclk:0
	out	ocr0a,r16





	;
	;*******************************************************************
	;b) timer1 (16bit)
	;tccr1a
	;wgm10=1 & wgm11=0 ;fast pwm 8-bit
	;com1a0=0 & com1a1=1 ;clear oc1a on compare match / set on top
	;com1b0=0 & com1b1=0 ;oc1b no timer function
	;tccr1b
	;wgm12=1 & wgm13=0 ;fast pwm 8-bit
	;cs10=0 & cs11=1 & cs12=0 ;flck/8
	;tcnt1h & tcnt1l =0
	;ocr1h & ocr1l= 0-255 (pulsw.)
	;********************************************************************
	clr	r16
	sbr	r16,1<<wgm10
	cbr	r16,1<<wgm11
	cbr	r16,1<<com1A0
	sbr	r16,1<<com1A1
	sts	tccr1a,r16	
	;
	clr	r16
	sbr	r16,1<<cs11
	cbr	r16,1<<wgm13
	sbr	r16,1<<wgm12
	sts	tccr1b,r16
	;
	clr	r16
	sts	tcnt1h,r16
	sts	tcnt1l,r16

	sts	ocr1ah,r16
	ldi	r16,170	;pwm pulsweite
	sts	NORMlight,r16
	sts	ocr1al,r16
	;
	;dimmed backlight
	ldi	r16,12
	sts	DIMlight,r16
	;




    ;............................................................
_INITgoB:
	;rep.counters preset
	ldi	zl,rc5repB
	sts	rc5codeREPa,zl		;repeatcounters

	;***********************VAR init *****************************
	;start position pointer=host_table
	ldi	zl,low(host_tableSHAD)
	ldi	zh,high(host_tableSHAD)
	sts	HtablePOSl,zl
	sts	HtablePOSh,zh	
	;prepare pointer
	ldi	zl,low(rfm_buffer)
	ldi	zh,high(rfm_buffer)		
	sts	TXbufPOINTl,zl
	sts	TXbufPOINTh,zh
	;prepare pointer
	ldi	zl,low(ack_buffer)
	ldi	zh,high(ack_buffer)		
    ;startadress <comNETpoint>
    ldi     xl,low(comNETbuffer)
    ldi     xh,high(comNETbuffer)
    sts     comNETpointL,xl
    sts     comNETpointH,xh


	;start scan-host
	ldi	zl,1
	sts	HscanCNT,zl
	;rx/tx-channel
	ldi	r16,10
	sts	RXch,r16
	sts	TXch,r16
    ;rfm on
    lds r16,hifGLOB
    sbr r16,1<<rfmENA
    sts hifGLOB,r16
  
    clr r16
    sts ifSELstate,r16
	;
	;***********************SPI init *****************************
	call	_SPImasterINIT

	;*********************** rfm12 receive************************
	;
	;store host adress to sram
	ldi	zh,high(host_adress_e2p)
	ldi	zl,low(host_adress_e2p)
    call    _RDe2big
	sts	Shost_adr,r22

  ; Move interrupts to Application Flash section
    ldi r16, (1<<IVCE)
    out MCUCR, r16
    clr r16
    out MCUCR, r16



   ;....................................................
	;check system state...
    lds     r16,hifGLOB
    sbrs     r16,disENA
    rjmp     _INITgoC     ;display disabled - don't init!
    ;...................................................




;******************************************************************************************
;startup
;******************************************************************************************
        ;display initialisieren
        call		_initDIS	;display an / 

;...............................................................................
;variablen initialisieren 
;...............................................................................
  _INITgoC:
        clr	xl
        sbr	xl,1<<newHIFdata	;bufferdaten vorhanden 
        cbr	xl,1<<spiBUSYhif		;
        sts	comFLAG,xl
        ;mit upperINDEX=0 starten
        clr	xl
        sts	upperINDEX,xl
        ;mir cursorINDEX=0 starten
        clr	xl
        sts	curINDEX,xl
        ;drehraten/cursor-flag =0 starten (wird im sysIF freigegeben)
        clr	xl
        cbr	xl,1<<BOXcursor ;cursorroutine disable
        sts	curMODflTE,xl
        ;
        clr	xl
        sts	spiDATctIST,xl
        ;GsymFL=0
        sts	GsymFL,xl
;...............................................................................


	;+++++++++++++++++++++++++++++++++++++++++++
	;++++++++ freecoder aktivieren ? +++++++++++
	;+++++++++++++++++++++++++++++++++++++++++++
	sbic	pind,progi
	rjmp	_runSYSTEM
	;freecoder aktivieren !
	;<=> taste beim booten gedrckt
			;a) wait freecoder maske darstellen....
			call	_SYSmsgA
			call	_sys01IF
	
			;b) taste >3 sekunden gedrckt == rc5freecoder enabled !
			clr	r16
			sts	bootACNTl,r16
			sts	bootACNTh,r16
			sts	bootBCNTl,r16
			sts	bootBCNTh,r16
			;counter laden...
			lds	zl,bootACNTl
			lds	zh,bootACNTh
			lds	yl,bootBCNTl
			lds	yh,bootBCNTh
	_glcdBOOTloopA:
			sbic	pind,progi
			rjmp	_runSYSTEM
			;zuerst B counter prfen
			;>=500 == freecoder entry
			cpi	yl,low(bootEND)		;Compare low byte
			ldi	r16,high(bootEND)	;
			cpc	yh,r16				;Compare high byte
			brsh	_glcdFREECODER	;...FREECODER ENTRY !
			;jetzt A counter prfen
			;luft durch 0....65535
			adiw	zh:zl,1			;counter A +1
			cpi	zl,low(bootCT)		;Compare low byte
			ldi	r16,high(bootCT)	;
			cpc	zh,r16	
			brlo	_glcdBOOTloopA	;loop...
			;boot counter B+1
			adiw	yh:yl,1
			;clr  counter A
			clr		zh
			clr		zl
			rjmp	_glcdBOOTloopA	;loop...
			 

;...FREECODER ENTRY !
_glcdFREECODER:	
			;b) freecoder maske darstellen....
			call	_SYSmsgB
			;darstellen
			call	_sys01IF
         ;clear rc5 data table
            clr zl
            clr zh
            ldi r22,0xff
        _glcdFREECODERloopX:
            call    _WRe2
            cpi    zl,0x5a
            brsh   _glcdFREECODERwt     ;max reached (90 bytes) 
            adiw    zh:zl,1
            rjmp    _glcdFREECODERloopX 


			;------------------------------
			;nun taste loslassen...
			;bei wiederholter bettigung 
			;wirdas Ganze beendet !
_glcdFREECODERwt:
			sbis	pind,progi		 	
			rjmp	_glcdFREECODERwt
			;-------------------------------
		
			;d)enable learnmode
			clr		r17
			sbr		r17,1<<learnX
			sts		rc5decFL,r17
			;e)clr prozess cnt
			clr		r17
			sts	rc5freeCNT,r17		;prozesscounter...
			ldi		r17,0xff
			sts	rc5datPRbk,r17
			;c) timer2 int enabled 
			ldi	r16,tiREL		;s reload 
			sts	tcnt2,r16
			;f) enable global interupts
			sei
_glcdFREECODERloop:
			lds		r17,rc5decFL
			sbrc	r17,learnX					
			rjmp	_glcdFREECODERloop
			;bertragung z.display freigeben
			cli
			clr	xl
			sbr	xl,1<<newHIFdata	;HIF-bufferdaten vorhanden 
			cbr	xl,1<<spiBUSYhif		;
			sts	comFLAG,xl
			;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
									_runSYSTEM:			
									;startdisplay
									call _SYSmsgC
									;darstellen
									call	_sys01IF




							

	;...........................................
	;copy host-table(e2p)
	;to sram
	;...........................................
	call	HOTBL_copy

;.............................................................................
;enable watchdog
;.............................................................................
; Reset Watchdog Timer
wdr
; Start timed sequence
lds r16, WDTCSR
ori r16, (1<<WDCE) | (1<<WDE)
sts WDTCSR, r16
; -- Got four cycles to set the new values from here -
; Set new prescaler(time-out) value = 512K cycles (~4s)
ldi r16, (1<<WDE) | (1<<WDP3); | (1<<WDP1)| (1<<WDP0)
sts WDTCSR, r16
; -- Finished setting new values, used 2 cycles -


;***********************SPI rfm init *****************************
call    _SPImasterRFMINIT
;..............................................................................
;init the rfm12
;call	rfm12_startinit
call    rfm12_RXinit   
;.............................................................................
;
;spi als slave initialisieren (auch interrupt freigeben)
call	_SPIslaveINIT
;............................................................................



;............................................................................
;MAIN-LOOP
;............................................................................
_MAINloop:
;A)key pressed
sbis	pind,progi
rjmp	_SOFTreset		;new start...
call	_sys01IF	;daten interpretieren

;..................................................
;new - check for new rfm-data
;..................................................
  
	;...............................
	;NEW: is there any received data
	;in rfm waiting...
	;if there's the frame complete
	;then receive data from rfm !
    ;...............................
    lds	r23,TRANS_state    
    ;.....................................
    ;check if there's too old data in fifo
    ;.....................................
    sbrs    r23,nRF_RXreq
    rjmp   _MAINloopC           ;nothing to do...
    ;............................
    ;0=NO new int0 occured
    ;1=YES there is data in 
    ;the rfm fifo - but too old
    ;now init the receiver...
    ;NOTE: only if spi's not busy
    ;...........................
    cli
    ;...........................
    ;perhaps an int0 INT occured
    ;= clear it !
    ;...........................
    sbi     eifr,intf0
    ;...........................
    sbis    pinb,_IFsel
    rjmp    _MAINloopBC          ;spi activ...
    ;spi is free
    ;now init the receiver
    call    _SPImasterRFMINITb
    ;reset fifo // wait for next sync - spi slave mode...
    call    rfm12_FIFOresdata 
    call    _SPIslaveINITb
    lds	r23,TRANS_state    
    cbr r23,1<<nRF_RXreq
 	sts	TRANS_state,r23
_MAINloopBC:
    sei  

    

;---------------------------------------------------
_MAINloopC:
;net-data translation
;call	rfm12_000run
;drehratendecoder inkl. cursorsteuerung aufrufen
call	_graphCURSOR
;graphische symbole darstellen	
call	_Gsym
;net-data translation
call	rfm12_000run
;system intruction
call    _sysINST
;net/hif data to conceptXM1.2
call	_conceptSND
;wdr
wdr
jmp	_MAINloop
;-----------------soft reset------------------
_SOFTreset:
	cli
; Reset Watchdog Timer
wdr
; Clear WDRF in MCUSR
in r16, MCUSR
andi r16, (0xff & (0<<WDRF))
out MCUSR, r16
; Write logical one to WDCE and WDE
; Keep old prescaler setting to prevent unintentional time-out
lds r16, WDTCSR
ori r16, (1<<WDCE) | (1<<WDE)
sts WDTCSR, r16
; Turn off WDT
ldi r16, (0<<WDE)
sts WDTCSR, r16



	jmp	_initSYS
	











;*******************************************************************************************
;include files
.include "#spiIRQ_B.inc"
.include "#spiINIT.inc"
.include "#timINT.inc"
.include "__Gcursor.inc"
.include "__Ginterpreter.inc"
.include "__GfontZ.inc"
.include "__GRAPHcom.inc"
.include "__Gtext.inc"
.include "__Grectangle.inc"
.include "__GcalcPAGEnDIS.inc"
.include "__GgraphTBL.inc"
.include "__Gsymbol.inc"
.include "__GlightB.inc"
.include "__GsysMSG.inc"
.include "__GsysINS.inc"
.include "__GsysTBL.inc"

;----------------------------------
;for rfm12
;include files
.include "#spiTX_NEW.inc"
.include "#uartREC.inc"
.include "#GLOBAL_sub.inc"
.include "_rfmCONtable.inc"
.include "_STOscan.inc"
.include "_rfmCOMlayerB.inc"
.include "_rfmCOM.inc"
.include "_rfmTXlayerMAN.inc"
.include "_rfmRXlayer_FIFO.inc"
.include "_nIRQrfmMAN_FiFo.inc"


