;------------------------------------------------------------
;system spi flags: comFLAG		=	0x15a	;kommunikation flag-variable
;-> flags (comFLAG)
;newHIFdata	    =	0		;new HIF-data in buffer - flag
;spiBUSYhif	    =	1		;HIF datenbertragung aktiv (RX/TX)
;newHIFtx	    =	2		;new HIF-data to send
;waitHIFdata    =   3       ;wait for hif-data from system after transmitting index... 
;spiBUSYnet     =   4       ;NET datenbetragung aktiv (RX/TX)
;newNETdata     =   5       ;new received NET-data in buffer
;newNETtx       =   6       ;new NET-data to send
;RFMbusy        =   7       ;rfm-h_if communication busy


;rfm & uart flags <TRANS_state>
;nRFov		    	=	0		;rfm12 data overflow
;nRFrxDATA			=	1		;new (rfm12)received data waits in rfm...
;nRFirqEV			=	2		;nIRQ event
;nRF_RXrun			=	3		;receive active
;UARTdataTXTO		=	4		;new data to transmit to system
;UARTdata			=	5		;new	(uart)received data in rx_buffer 
;UARTdataREC		=	6		;uart receives data (needs rx_buffer)
;UARTdataTX			=	7	    ;uart's transmitting data from tx_buffer
    
;....................................................
;Send data to conceptXM1.2
;....................................................
_conceptSND:
 	;........................
	;new NET-data to send ?
	;........................
	lds	r16,comNETstate
	sbrc	r16,comNETnewDATtx		;is there any frame to transmit to the spi?
	rjmp	_conceptSNDnet			;yes - actually...
	;.........................
	;new HIF-data to send ?
	;.........................
	lds	r16,comFLAG
	sbrs	r16,newHIFtx			;1= send data
	rjmp	_conceptSNDbk			;back...


;........................................................................................
;HIF-data to conceptXM1.2
;........................................................................................
    ;........................................
	;check system state...
    lds     r16,hifGLOB
    sbrs     r16,disENA
    rjmp     _conceptSNDfail             ;display disabled
    ;........................................

    ;........................................
    ;NEW
    ;check remote state
    lds     r16,REMif
    sbrc    r16,REMstate
    rjmp    _conceptSNDrem               ;remote master == don't send data to system, but to slave!
    ;........................................


    ;check bus...
    sbis    pinb,_IFsel
    rjmp    _conceptSNDbk       ;bus not free....
 	;enable spi
	call	_SPImasterINIT ;als master konfigurieren
   ;free...
	;set bus busy - the others 
    ;have to wait !
	;set spi busy...
	lds	r16,comFLAG
	sbr	r16,1<<spiBUSYhif		;1=spi hif-data demnchst aktiv...
	sts	comFLAG,r16


    cbi	portb,_SS
    nop
    nop
    nop
    ldi     xl,0x2d         ;start identifier for the receiver !
	call	_sndPARAspiDO
	lds		xl,curINDEXte
	call	_sndPARAspiDO
	lds		xl,paraFUNCte
	call	_sndPARAspiDO
	lds		xl,paraPOSte
	call	_sndPARAspiDO
	lds		xl,paraAte
	call	_sndPARAspiDO
	lds		xl,paraMINte
	call	_sndPARAspiDO
	lds		xl,paraMAXte
	call	_sndPARAspiDO
	;set spi free...
	lds	r16,comFLAG
    cbr r16,1<<newHIFtx
	cbr	r16,1<<spiBUSYhif	;1=spi hif-data ready transmitted 
;    sbr r16,1<<waitHIFdata  ;-> wait for concept-data... cleared after receive !
	sts	comFLAG,r16
	;disable spi
	;wieder als int-slave...
	call	_SPIslaveINIT

_conceptSNDbk:
	ret
    
    ;hif disabled
_conceptSNDfail:
    lds	r16,comFLAG
    cbr r16,1<<newHIFtx
	cbr	r16,1<<spiBUSYhif	;1=spi hif-data ready transmitted 
	sts	comFLAG,r16
    ret

    ;remote master...
_conceptSNDrem:
    lds	r16,comFLAG
    cbr r16,1<<newHIFtx
	cbr	r16,1<<spiBUSYhif	;1=spi hif-data ready transmitted 
	sts	comFLAG,r16
    ;NEW for remote
    ldi r17,REMconDAT           ;controller data  (master => slave)
    sts REMtype,r17
    ;data size
    ldi r17,6
    sts REMsize,r17
    ;stateSEND
    ldi r17,10
    sts STATEsend,r17
    ret



;........................................................................................
;NET-data to conceptXM1.2
;........................................................................................
_conceptSNDnet:
   ;check bus...
    sbis    pinb,_IFsel
    rjmp    _conceptSNDbk       ;bus not free....
    ;free...
	call	_SPImasterINIT ;als master konfigurieren
	;set spi busy...
	lds	r16,comFLAG
	sbr	r16,1<<spiBUSYnet		;1=spi net-data aktiv
	sts	comFLAG,r16
    ;
    cbi	portb,_SS
	;first load frame_size
	ldi	zl,5
	clr	zh
	subi	zl,low(-TX_buffer)
	sbci	zh,high(-TX_buffer)
	ld	r19,z
	;set startadress
	ldi	zl,low(TX_buffer)
	ldi	zh,high(TX_buffer)
	;set bytecounter
	clr	r17
	;start identifier
    ldi xl,0xd4
	call	_sndPARAspiDO
	;
_conceptSNDnetLOOP:
	inc	r17
	ld	xl,z+
	call	_sndPARAspiDO
	;now check exit state
	cp	r17,r19
	brsh	_conceptSNDnetLOOPexit
	rjmp	_conceptSNDnetLOOP
_conceptSNDnetLOOPexit:
	;ready transmitted...
	lds	r16,comNETstate
	cbr	r16,1<<comNETnewDATtx
	sts	comNETstate,r16
	;wieder als slave...
	call	_SPIslaveINIT
	jmp	_conceptSNDbk	







;..................................................
;HIF/NET-data to conceptXM1.2
;..................................................
	;
	;nach spi
_sndPARAspiDO:
	out	spdr,xl
_sndPARAspiDOloop:
	in	r16,spsr
	sbrs	r16,spif
	rjmp	_sndPARAspiDOloop
	;dummy read spdr
	in	r16,spdr  
	ret







;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;RX/TX RFM SPI sub
;MSB to 	slave = toMSB	
;MSB	from slave = fromMSB
;LSB	to   slave = toLSB
;LSB from slave = from LSB
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;send via SPI
rfm12_initSPI:
    push    r16
	;enable spi
	cbi	portb,_nSEL
	nop
    nop
    nop
rfm12_initSPIloop_AA:
	;lade MSB
	lds	r16,toMSB
	out	spdr,r16
    
    ;................................................................
    ;COLLISION DETECT
    ;test
;    in	r16,spsr
;	sbrc	r16,wcol
;	rjmp	rfm12_initSPIloop_AA		;warte bis daten bertragen
    ;................................................................

    	
rfm12_initSPIloop_A:
 	in	r16,spsr
	sbrs	r16,spif
	rjmp	rfm12_initSPIloop_A		;warte bis daten bertragen
	;read spdr
	in	r16,spdr
	sts	fromMSB,r16
	;lade LSB
	lds	r16,toLSB
	out	spdr,r16
rfm12_initSPIloop_B:
   	in	r16,spsr
	sbrs	r16,spif
	rjmp	rfm12_initSPIloop_B		;warte bis daten bertragen
	;read fifo
	in	r16,spdr
	sts	fromLSB,r16
	;disable spi
    nop
	sbi	portb,_nSEL
    pop r16
	ret









